#include "hardware_t.h"
#include "tc_vars.h"
#include "flash_t.h"
#include "display_t.h"
//#include "math.h"

// Class Display
//##########################################################################################################################################################
//BF changed due to new grid dimension and replaced switch against indexed array fetched
void Display::CALCCURSORDATA(void)  								// channel = source im cursor menu
{
	int buf_int = 0;	
		
	//BF del char doit = 0;	
	int volt = 0;		
	int zero = 0;		
	int voltmfactor = 0;
	float vfactor  = 0;	
	float vfactor2 = 0;	
	float voltoff  = 0;		
	
	int time = 0;
	float tfactor = 0;
	float timeoff = 0;			
	
	char BufferText[10];
	
	int channel = MenuStatus[16][0] - 26;
			
	switch(channel)
	{
	 	case 1:	// TMW comment added: case 1 means Cursor Source 1 set (use CH1 voltage)
		{				
			volt = Selected_Voltage_CH1;
			zero = ZeroLevelCH1;
			voltmfactor = MenuStatus[1][3];
			break;
		}
		case 2: // TMW comment added: case 2 means Cursor Source 2 set (use CH2 voltage)
		{				
			volt = Selected_Voltage_CH2;
			zero = ZeroLevelCH2;
			voltmfactor = MenuStatus[2][3];
			break;
		}
		case 3: // TMW comment added: case 3 means Cursor Source 3 set (use CH3 voltage)
		{				
			volt = Selected_Voltage_CH3;
			zero = ZeroLevelCH3;
			voltmfactor = MenuStatus[3][3];
			break;
		}
		case 4: // TMW comment added: case 4 means Cursor Source 4 set (use CH4 voltage)
		{				
			volt = Selected_Voltage_CH4;
			zero = ZeroLevelCH4;
			voltmfactor = MenuStatus[4][3];
			break;	
		}
	}
	

	switch(volt)
	{
		case 0 : vfactor = 20; break;
		case 1 : vfactor = 40; break;
		case 2 : vfactor = 100; break;
		case 3 : vfactor = 200; break;
		case 4 : vfactor = 400; break;
		case 5 : vfactor = 1000; break;
		case 6 : vfactor = 2000; break;
		case 7 : vfactor = 4000; break;
		case 8 : vfactor = 10000; break;
		case 9 : vfactor = 20000; break;
		case 10 : vfactor = 40000; break;
		case 11 : vfactor = 100000; break;
	}
	
	vfactor = vfactor / 1000000;

	switch(voltmfactor)
	{
		case 101: vfactor2 = 0.1; break;	
		case 102: vfactor2 = 0.2; break;
		case 103: vfactor2 = 0.5; break;
		case 104: vfactor2 = 1; break;
		case 105: vfactor2 = 2; break;
		case 106: vfactor2 = 5; break;
		case 107: vfactor2 = 10; break;
		case 108: vfactor2 = 20; break;
		case 109: vfactor2 = 50; break;
		case 110: vfactor2 = 100; break;
		case 111: vfactor2 = 200; break;
		case 112: vfactor2 = 500; break;
		case 113: vfactor2 = 1000; break;
	}	
	vfactor = vfactor * vfactor2;
	
	buf_int = zero - Cursor_Horizontal_Position_Real1;
	
	voltoff =  (float)buf_int * vfactor;  // Mitte ist (GRID_HEIGHT / 2) (0xC0) =>  Mitte 128 (0x80) * 1.5
	voltoff1 = voltoff;

	Cursor_Horizontal_Pos_1_Str.Write_Value(voltoff);
	Cursor_Horizontal_Pos_1_Str.RenderText();
		
	
	buf_int = zero - Cursor_Horizontal_Position_Real2;	
	
	voltoff =  (float)buf_int * vfactor;  // Mitte ist (GRID_HEIGHT / 2) (0xC0) =>  Mitte 128 (0x80) * 1.5
	voltoff2 = voltoff;

	Cursor_Horizontal_Pos_2_Str.Write_Value(voltoff);
	Cursor_Horizontal_Pos_2_Str.RenderText();	
	

	if (voltoff1 > voltoff2) voltoff = voltoff1 - voltoff2;
	else voltoff = voltoff2 - voltoff1;
	if (voltoff < 0) voltoff = -voltoff;

			
        if (XY_Mode)
        {			
            	sprintf(BufferText, "@Y = ");
        }
        else
        {			
		switch(channel)
		{
			case 1: sprintf(BufferText, "@Y [ = "); break;
			case 2: sprintf(BufferText, "@Y \\ = "); break;
			case 3: sprintf(BufferText, "@Y ] = "); break;
			case 4: sprintf(BufferText, "@Y ^ = "); break;
			case 5: sprintf(BufferText, "@Y(M) = "); break;
		}
        }
		
	Cursor_Delta_Y.Write_PreText(BufferText);
	Cursor_Delta_Y.Write_Value(voltoff);
	Cursor_Delta_Y.RenderText();				
	
	
	// für xy mode
	buf_int = Cursor_Vertical_Position_Real_XY_1 - 300;
	
	voltoff =  (float)buf_int * vfactor;  // Mitte ist (GRID_HEIGHT / 2) (0xC0) =>  Mitte 128 (0x80) * 1.5
	voltoff1 = voltoff;

	Cursor_Vertical_Pos_XY_1_Str.Write_Value(voltoff);
	Cursor_Vertical_Pos_XY_1_Str.RenderText();
		
	
	buf_int = Cursor_Vertical_Position_Real_XY_2 - 300;	
	
	voltoff =  (float)buf_int * vfactor;  // Mitte ist (GRID_HEIGHT / 2) (0xC0) =>  Mitte 128 (0x80) * 1.5
	voltoff2 = voltoff;

	Cursor_Vertical_Pos_XY_2_Str.Write_Value(voltoff);
	Cursor_Vertical_Pos_XY_2_Str.RenderText();	
	
	if (voltoff1 > voltoff2) voltoff = voltoff1 - voltoff2;
	else voltoff = voltoff2 - voltoff1;
	if (voltoff < 0) voltoff = -voltoff;

	sprintf(BufferText, "@X = ");

	
	Cursor_Delta_XY_X.Write_PreText(BufferText);
	Cursor_Delta_XY_X.Write_Value(voltoff);
	Cursor_Delta_XY_X.RenderText();				


	// BF -> changed to indexed array fetch!!
	tfactor = TimeBaseFactor[Display_Timebase] / 1000000 / ZFT_float;


    buf_int = (int) (((float) Cursor_Vertical_Position_Real1 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))) );// / ZFT_float);	
	

	timeoff =  (float)buf_int * tfactor;  // Mitte ist 300
	timeoff1 = timeoff;
		
	Cursor_Vertical_Pos_1_Str.Write_Value(timeoff);
	Cursor_Vertical_Pos_1_Str.RenderText();	
		

    buf_int = (int) (((float) Cursor_Vertical_Position_Real2 - ((float) SIG_Start_Stop[ZIT_short][0] + ((float) Timebase_Offset_Pos * OFT_float))) ); /// ZFT_float);		


	timeoff =  (float)buf_int * tfactor;  // Mitte ist 300
	timeoff2 = timeoff;

	Cursor_Vertical_Pos_2_Str.Write_Value(timeoff);	
	Cursor_Vertical_Pos_2_Str.RenderText();	
		
	
	if (timeoff1 > timeoff2) timeoff = timeoff1 - timeoff2;
	else timeoff = timeoff2 - timeoff1;
	if (timeoff < 0) timeoff = -timeoff;
	
	Cursor_Delta_X.Write_Value(timeoff);	
	Cursor_Delta_X.RenderText();
	
	timeoff = 1 / timeoff;
	Cursor_Delta_1X.Write_Value(timeoff);
	Cursor_Delta_1X.RenderText();
	
}
//##########################################################################################################################################################
//multiply signals
void Display::CalcMathMul(int start, int stop, int stepwidth ,unsigned char *SignalData1, unsigned char *SignalData2, unsigned char *MathData)
{
	int lix, lfactor;
	int lbuffer, lvalue1,lvalue2;
	

	for (lix = start; lix < stop  && !UI_request; lix+=stepwidth)
	{
		//convert to signed integer
		lvalue1 = SignalData1[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH1 / scale_factor[Selected_Voltage_CH1]));
		lvalue2 = SignalData2[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH2 / scale_factor[Selected_Voltage_CH2]));

		//scale signals
		lvalue1 = lvalue1 * math_voltage_factor[Selected_Voltage_CH1];
		lvalue2 = lvalue2 * math_voltage_factor[Selected_Voltage_CH2];
		
		//and rescale
		if (lvalue1 > 0)
		lvalue1 /= math_voltage_factor[math_scale];
		else if (lvalue1 < 0)
		{lvalue1 *= -1;lvalue1 /= math_voltage_factor[math_scale]; lvalue1 *= -1;}
		
		if (lvalue2 > 0)
		lvalue2 /= math_voltage_factor[math_scale];
		else if (lvalue2 < 0)
		{lvalue2 *= -1;lvalue2 /= math_voltage_factor[math_scale]; lvalue2 *= -1;}
		
		//predivision
		lvalue1 *= predivisor[MenuStatus[1][3] - 104];
		lvalue2 *= predivisor[MenuStatus[2][3] - 104];

		//calculate math signal
		lbuffer = lvalue1 * lvalue2;
						
		//limiter
		if (lbuffer > (ADC_ZERO+1))
		{ lbuffer = (ADC_ZERO+1);}
		else if (lbuffer < -ADC_ZERO)
		{ lbuffer = -ADC_ZERO;}

		//convert to unsigned and save as char
		MathData[lix] = lbuffer + ADC_ZERO;
	
	}


}
//##########################################################################################################################################################
//subtract signals
void Display::CalcMathSub(int start, int stop, int stepwidth ,unsigned char *SignalData1, unsigned char *SignalData2, unsigned char *MathData)
{

	int lix, lfactor;
	int lbuffer, lvalue1,lvalue2;

	for (lix = start; lix < stop  && !UI_request; lix+=stepwidth)
	{
		//convert to signed integer
		lvalue1 = SignalData1[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH1 / scale_factor[Selected_Voltage_CH1]));
		lvalue2 = SignalData2[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH2 / scale_factor[Selected_Voltage_CH2]));

		//scale signals
		lvalue1 = lvalue1 * math_voltage_factor[Selected_Voltage_CH1] * predivisor[MenuStatus[1][3] - 104];
		lvalue2 = lvalue2 * math_voltage_factor[Selected_Voltage_CH2] * predivisor[MenuStatus[2][3] - 104];
		
		//calculate math signal
		lbuffer = lvalue1 - lvalue2;
		
		//and rescale
		if (lbuffer > 0)
		lbuffer /= math_voltage_factor[math_scale];
		else if (lbuffer < 0)
		{lbuffer *= -1;lbuffer /= math_voltage_factor[math_scale]; lbuffer *= -1;}
		
		//limiter
		if (lbuffer > (ADC_ZERO+1))
		{ lbuffer = (ADC_ZERO+1);}
		else if (lbuffer < -ADC_ZERO)
		{ lbuffer = -ADC_ZERO;}
		
		//convert to unsigned and save as char
		MathData[lix] = lbuffer + ADC_ZERO;
	}


}
//##########################################################################################################################################################
//add signals
void Display::CalcMathAdd(int start, int stop, int stepwidth ,unsigned char *SignalData1, unsigned char *SignalData2, unsigned char *MathData)
{
	int lix, lfactor;
	int lbuffer, lvalue1,lvalue2;

	for (lix = start; lix < stop  && !UI_request; lix+=stepwidth)
	//for (lix = draw_start + Trigger_Offset_Calc; lix < lstop && !UI_request; lix+=lfactor)
	{
		//convert to signed integer
		lvalue1 = SignalData1[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH1 / scale_factor[Selected_Voltage_CH1]));
		lvalue2 = SignalData2[lix] - (ADC_ZERO + int((float)Virtual_ZeroLevelCH2 / scale_factor[Selected_Voltage_CH2]));

		//scale signals
		lvalue1 = lvalue1 * math_voltage_factor[Selected_Voltage_CH1] * predivisor[MenuStatus[1][3] - 104];
		lvalue2 = lvalue2 * math_voltage_factor[Selected_Voltage_CH2] * predivisor[MenuStatus[2][3] - 104];
		
		//calculate math signal
		lbuffer = lvalue1 + lvalue2;

		//and rescale
		if (lbuffer > 0)
		lbuffer /= math_voltage_factor[math_scale];
		else if (lbuffer < 0)
		{ lbuffer *= -1;lbuffer /= math_voltage_factor[math_scale]; lbuffer *= -1;}
		
		//limiter
		if (lbuffer > (ADC_ZERO+1))
		{ lbuffer = (ADC_ZERO+1);}
		else if (lbuffer < -ADC_ZERO)
		{ lbuffer = -ADC_ZERO;}

		//convert to unsigned and save as char
		MathData[lix] = lbuffer + ADC_ZERO;
	}


}
//##########################################################################################################################################################
// BF -> Quick Measure completely redesigned by Stefan
void Display::CALCQMDATA(void)
{
 //BF	#define _Debug_QM_
	
    float BufVal = 1;

    int step=0, ixs=0, ixss=0, cnt=0, mid_buf = 0;
    int off_buf = 0;
    short PBuf;

    short thres_low = (int) QM_Threshold_lower.Read_Value();
    short thres_mdl = (int) QM_Threshold_middle.Read_Value();
    short thres_up = (int) QM_Threshold_upper.Read_Value();

    short SIGNAL_THRES_PRE_POSITIV = -1;
    short SIGNAL_THRES_LOW_POSITIV = -1;
    short SIGNAL_THRES_MDL_POSITIV = -1;
    short SIGNAL_THRES_UP_POSITIV = -1;
    short SIGNAL_THRES_OVER_POSITIV = -1;

    short SIGNAL_THRES_PRE_NEGATIV = -1;
    short SIGNAL_THRES_LOW_NEGATIV = -1;
    short SIGNAL_THRES_MDL_NEGATIV = -1;
    short SIGNAL_THRES_UP_NEGATIV = -1;
    short SIGNAL_THRES_OVER_NEGATIV = -1;

	unsigned char *LPSIGNAL = 0;
	int channel=0;
    // muß überarbeitet werden
    //rot_int->np_piointerruptmask = 0x00;
    //key_int->np_piointerruptmask = 0x00;
	

#ifdef _Debug_QM_
    if (Debug_Mode)
    {
        printf("QM ixs %d ixss %d\n", ixs, ixss);
        printf("QM_TYPE[0] %d QM_TYPE[1] %d QM_TYPE[2] %d\n", QM_Type[0], QM_Type[1], QM_Type[2]);
        printf("QM_Channel[0] %d QM_Channel[1] %d QM_Channel[2] %d\n", QM_Channel[0], QM_Channel[1], QM_Channel[2]);
    }
#endif

    if (QM_Type[0] == 2)
    {
        QM_Second_Channel[0] = MenuStatus[20][2] - 26;
        QM_CHI_Edge[0] = MenuStatus[20][1] - 1;            // 1 = positiv , 2 = negativ
        QM_CHII_Edge[0] = MenuStatus[20][3] - 1;
    }
    else if (QM_Type[0] == 10)
    {
        QM_Second_Channel[0] = MenuStatus[20][2] - 26;
    }
    else QM_Second_Channel[0] = 0;

    if (QM_Type[1] == 2)
    {
        QM_Second_Channel[1] = MenuStatus[20][2] - 26;
        QM_CHI_Edge[1] = MenuStatus[20][1] - 1;            // 1 = positiv , 2 = negativ
        QM_CHII_Edge[1] = MenuStatus[20][3] - 1;
    }
    else if (QM_Type[1] == 10)
    {
        QM_Second_Channel[1] = MenuStatus[20][2] - 26;
    }
    else QM_Second_Channel[1] = 0;

    if (QM_Type[2] == 2)
    {
        QM_Second_Channel[2] = MenuStatus[20][2] - 26;
        QM_CHI_Edge[2] = MenuStatus[20][1] - 1;            // 1 = positiv , 2 = negativ
        QM_CHII_Edge[2] = MenuStatus[20][3] - 1;
    }
    else if (QM_Type[2] == 10)
    {
        QM_Second_Channel[2] = MenuStatus[20][2] - 26;
    }
    else QM_Second_Channel[2] = 0;


    // Max = Top Screen - positiv Voltage
    // Min = Bottom Screen - negativ Voltage
	
	ixs=MemWinStart+Trigger_Offset_Calc;//left edge in mem
	//printf("ixs: %d, memSTart: %d\n",ixs,MemWinStart);
	ixss=ixs+GRID_WIDTH*draw_factor;
	
	step=draw_factor;
	if (step==0)
		step=1;
	//if (ixss>


	for (channel=1;channel<=4;channel++){
		SIGNAL_AVG_CNT[channel-1] = 0;
		SIGNAL_AVG[channel-1] = 0;
			
		if ((QM_Channel[0] == channel) || (QM_Channel[1] == channel) || (QM_Channel[2] == channel) || (QM_Second_Channel[0] == channel) || (QM_Second_Channel[1] == channel) || (QM_Second_Channel[2] == channel))
		{
        SIGNAL_MAX[channel-1] = 255;
        SIGNAL_MIN[channel-1] = 0;
		
		switch(channel){
			case 1:
				LPSIGNAL=SIGNAL1;
				break;
			case 2:
				LPSIGNAL=SIGNAL2;
				break;
			case 3:
				LPSIGNAL=SIGNAL3;
				break;
			case 4:
				LPSIGNAL=SIGNAL4;
				break;
		}
		
        for (cnt = 0; cnt < 256; cnt++) SIGNAL_Histo[cnt+(channel-1)*256] = 0;
//*******************************************************************************************
		for (cnt = ixs; cnt < ixss; cnt+=step)
		{
			SIGNAL_Histo[LPSIGNAL[cnt]+(channel-1)*256]++;

			if (SIGNAL_MAX[channel-1] > LPSIGNAL[cnt]) SIGNAL_MAX[channel-1] = LPSIGNAL[cnt];
			if (SIGNAL_MIN[channel-1] < LPSIGNAL[cnt]) SIGNAL_MIN[channel-1] = LPSIGNAL[cnt];
		}
        

        if (SIGNAL_MAX[channel-1] > SIGNAL_MIN[channel-1])
        {
            PBuf = SIGNAL_MAX[channel-1];
            SIGNAL_MAX[channel-1] = SIGNAL_MIN[channel-1];
            SIGNAL_MIN[channel-1] = PBuf;
        }
		#ifdef _Debug_QM_
		//printf("channel: %d SIGNAL_MAX[channel-1] %d, SIGNAL_MIN[channel-1] %d, ixs %d, ixss %d\n",channel,SIGNAL_MAX[channel-1],SIGNAL_MIN[channel-1],ixs,ixss);
		#endif


        SIGNAL_MDL[channel-1] = (SIGNAL_MIN[channel-1] + SIGNAL_MAX[channel-1]) >> 1;

        SIGNAL_TOP[channel-1] = 0;
        SIGNAL_BASE[channel-1] = 0;
        PBuf = 0;

        mid_buf = (int) ((SIGNAL_MIN[channel-1] + SIGNAL_MAX[channel-1]) / 2);

        for (cnt = 0; cnt < mid_buf; cnt++)
        {
            if (SIGNAL_Histo[cnt+(channel-1)*256] > PBuf)
            {
                PBuf = SIGNAL_Histo[cnt+(channel-1)*256];
                SIGNAL_TOP[channel-1] = cnt;
            }
        }

        PBuf = 0;

        for (cnt = 255; cnt > mid_buf; cnt--)
        {
            if (SIGNAL_Histo[cnt+(channel-1)*256] > PBuf)
            {
                PBuf = SIGNAL_Histo[cnt+(channel-1)*256];
                SIGNAL_BASE[channel-1] = cnt;
            }
        }

        if (SIGNAL_TOP[channel-1] > SIGNAL_BASE[channel-1])
        {
            PBuf = SIGNAL_TOP[channel-1];
            SIGNAL_TOP[channel-1] = SIGNAL_BASE[channel-1];
            SIGNAL_BASE[channel-1] = PBuf;
        }

        SIGNAL_THRES_UP[channel-1]  = (short) (SIGNAL_BASE[channel-1] - (((float) thres_up / 100) * (SIGNAL_BASE[channel-1] - SIGNAL_TOP[channel-1])));
        SIGNAL_THRES_MDL[channel-1] = (short) (SIGNAL_BASE[channel-1] - (((float) thres_mdl / 100) * (SIGNAL_BASE[channel-1] - SIGNAL_TOP[channel-1])));
        SIGNAL_THRES_LOW[channel-1] = (short) (SIGNAL_BASE[channel-1] - (((float) thres_low / 100) * (SIGNAL_BASE[channel-1] - SIGNAL_TOP[channel-1])));
#ifdef _Debug_QM_
        if (Debug_Mode)
        {
            printf("1 : tl %d tm %d tu %d\n", thres_low, thres_mdl, thres_up);
            printf("1 : THR2L %d THR2M %d THR2U %d \n", SIGNAL_THRES_LOW[channel-1], SIGNAL_THRES_MDL[channel-1], SIGNAL_THRES_UP[channel-1]);
            printf("1 : Top %d Base %d \n", SIGNAL_TOP[channel-1], SIGNAL_BASE[channel-1]);
            printf("1 : Min %d Mdl %d Max %d\n", SIGNAL_MIN[channel-1], SIGNAL_MDL[channel-1], SIGNAL_MAX[channel-1]);
        }
#endif
		SIGNAL_THRES_PRE_POSITIV_1[channel-1] = -1;
        SIGNAL_THRES_LOW_POSITIV_1[channel-1] = -1;
        SIGNAL_THRES_MDL_POSITIV_1[channel-1] = -1;
        SIGNAL_THRES_UP_POSITIV_1[channel-1] = -1;
        SIGNAL_THRES_OVER_POSITIV_1[channel-1] = -1;

        SIGNAL_THRES_PRE_NEGATIV_1[channel-1] = -1;
        SIGNAL_THRES_LOW_NEGATIV_1[channel-1] = -1;
        SIGNAL_THRES_MDL_NEGATIV_1[channel-1] = -1;
        SIGNAL_THRES_UP_NEGATIV_1[channel-1] = -1;
        SIGNAL_THRES_OVER_NEGATIV_1[channel-1] = -1;

        SIGNAL_THRES_PRE_POSITIV_2[channel-1] = -1;
        SIGNAL_THRES_LOW_POSITIV_2[channel-1] = -1;
        SIGNAL_THRES_MDL_POSITIV_2[channel-1] = -1;
        SIGNAL_THRES_UP_POSITIV_2[channel-1] = -1;
        SIGNAL_THRES_OVER_POSITIV_2[channel-1] = -1;

        SIGNAL_THRES_PRE_NEGATIV_2[channel-1] = -1;
        SIGNAL_THRES_LOW_NEGATIV_2[channel-1] = -1;
        SIGNAL_THRES_MDL_NEGATIV_2[channel-1] = -1;
        SIGNAL_THRES_UP_NEGATIV_2[channel-1] = -1;
        SIGNAL_THRES_OVER_NEGATIV_2[channel-1] = -1;

        SIGNAL_THRES_PRE_NEGATIV_LAST[channel-1] = -1;
        SIGNAL_THRES_LOW_NEGATIV_LAST[channel-1] = -1;
        SIGNAL_THRES_MDL_NEGATIV_LAST[channel-1] = -1;
        SIGNAL_THRES_UP_NEGATIV_LAST[channel-1] = -1;
        SIGNAL_THRES_OVER_NEGATIV_LAST[channel-1] = -1;

       
            for (cnt = ixs; cnt < ixss; cnt+=step)
            {
                if ((SIGNAL_THRES_MDL_POSITIV_1[channel-1] != 1) && (SIGNAL_THRES_MDL_POSITIV_LAST[channel-1] != -1))
                {
                    SIGNAL_AVG[channel-1] += (LPSIGNAL[cnt] - SIGNAL_THRES_MDL[channel-1]);
                    SIGNAL_AVG_CNT[channel-1]++;
                }

                if (SIGNAL_THRES_UP_POSITIV_1[channel-1] == -1)
                {
                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_LOW_POSITIV_1[channel-1] == -1)) SIGNAL_THRES_PRE_POSITIV_1[channel-1] = cnt;
                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_LOW[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_MDL[channel-1]) && (SIGNAL_THRES_PRE_POSITIV_1[channel-1] != -1) && (SIGNAL_THRES_LOW_POSITIV_1[channel-1] == -1)) SIGNAL_THRES_LOW_POSITIV_1[channel-1] = cnt;
                    else if ((LPSIGNAL[cnt] < SIGNAL_THRES_LOW[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_PRE_POSITIV_1[channel-1] != -1) && (SIGNAL_THRES_LOW_POSITIV_1[channel-1] == -1)) SIGNAL_THRES_LOW_POSITIV_1[channel-1] = cnt;

                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_LOW_POSITIV_1[channel-1] != -1) && (SIGNAL_THRES_MDL_POSITIV_1[channel-1] == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV_1[channel-1] = cnt ;
                        SIGNAL_THRES_LOW_POSITIV_1[channel-1] = -1;
                    }
                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_LOW_POSITIV_1[channel-1] != -1) && (SIGNAL_THRES_MDL_POSITIV_1[channel-1] == -1)) SIGNAL_THRES_MDL_POSITIV_1[channel-1] = cnt ;
                    else if ((LPSIGNAL[cnt] < SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_LOW_POSITIV_1[channel-1] != -1) && (SIGNAL_THRES_MDL_POSITIV_1[channel-1] == -1)) SIGNAL_THRES_MDL_POSITIV_1[channel-1] = cnt ;

                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_MDL_POSITIV_1[channel-1] != -1) && (SIGNAL_THRES_UP_POSITIV_1[channel-1] == -1)) SIGNAL_THRES_UP_POSITIV_1[channel-1] = cnt ;
                }
                if (SIGNAL_THRES_LOW_NEGATIV_1[channel-1] == -1)
                {
                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_UP_NEGATIV_1[channel-1] == -1)) SIGNAL_THRES_OVER_NEGATIV_1[channel-1] = cnt ;
                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_UP[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_MDL[channel-1]) && (SIGNAL_THRES_OVER_NEGATIV_1[channel-1] != -1) && (SIGNAL_THRES_UP_NEGATIV_1[channel-1] == -1)) SIGNAL_THRES_UP_NEGATIV_1[channel-1] = cnt ;
                    else if ((LPSIGNAL[cnt] > SIGNAL_THRES_UP[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_OVER_NEGATIV_1[channel-1] != -1) && (SIGNAL_THRES_UP_NEGATIV_1[channel-1] == -1)) SIGNAL_THRES_UP_NEGATIV_1[channel-1] = cnt ;

                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_UP_NEGATIV_1[channel-1] != -1) && (SIGNAL_THRES_MDL_NEGATIV_1[channel-1] == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV_1[channel-1] = cnt ;
                        SIGNAL_THRES_UP_NEGATIV_1[channel-1] = -1;
                    }
                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_UP_NEGATIV_1[channel-1] != -1) && (SIGNAL_THRES_MDL_NEGATIV_1[channel-1] == -1)) SIGNAL_THRES_MDL_NEGATIV_1[channel-1] = cnt ;
                    else if ((LPSIGNAL[cnt] > SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_UP_NEGATIV_1[channel-1] != -1) && (SIGNAL_THRES_MDL_NEGATIV_1[channel-1] == -1)) SIGNAL_THRES_MDL_NEGATIV_1[channel-1] = cnt ;

                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_MDL_NEGATIV_1[channel-1] != -1) && (SIGNAL_THRES_LOW_NEGATIV_1[channel-1] == -1)) SIGNAL_THRES_LOW_NEGATIV_1[channel-1] = cnt ;
                }
                if ((SIGNAL_THRES_UP_POSITIV_1[channel-1] != -1) && (SIGNAL_THRES_UP_POSITIV_2[channel-1] == -1))
                {
                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_LOW_POSITIV_2[channel-1] == -1)) SIGNAL_THRES_PRE_POSITIV_2[channel-1] = cnt ;
                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_LOW[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_MDL[channel-1]) && (SIGNAL_THRES_PRE_POSITIV_2[channel-1] != -1) && (SIGNAL_THRES_LOW_POSITIV_2[channel-1] == -1)) SIGNAL_THRES_LOW_POSITIV_2[channel-1] = cnt ;
                    else if ((LPSIGNAL[cnt] < SIGNAL_THRES_LOW[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_PRE_POSITIV_2[channel-1] != -1) && (SIGNAL_THRES_LOW_POSITIV_2[channel-1] == -1)) SIGNAL_THRES_LOW_POSITIV_2[channel-1] = cnt ;

                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_LOW_POSITIV_2[channel-1] != -1) && (SIGNAL_THRES_MDL_POSITIV_2[channel-1] == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV_2[channel-1] = cnt ;
                        SIGNAL_THRES_LOW_POSITIV_2[channel-1] = -1;
                    }
                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_LOW_POSITIV_2[channel-1] != -1) && (SIGNAL_THRES_MDL_POSITIV_2[channel-1] == -1)) SIGNAL_THRES_MDL_POSITIV_2[channel-1] = cnt ;
                    else if ((LPSIGNAL[cnt] < SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_LOW_POSITIV_2[channel-1] != -1) && (SIGNAL_THRES_MDL_POSITIV_2[channel-1] == -1)) SIGNAL_THRES_MDL_POSITIV_2[channel-1] = cnt ;

                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_MDL_POSITIV_2[channel-1] != -1) && (SIGNAL_THRES_UP_POSITIV_2[channel-1] == -1)) SIGNAL_THRES_UP_POSITIV_2[channel-1] = cnt ;
                }
                if ((SIGNAL_THRES_LOW_NEGATIV_1[channel-1] != -1) && (SIGNAL_THRES_LOW_NEGATIV_2[channel-1] == -1))
                {
                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_UP_NEGATIV_2[channel-1] == -1)) SIGNAL_THRES_OVER_NEGATIV_2[channel-1] = cnt ;
                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_UP[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_MDL[channel-1]) && (SIGNAL_THRES_OVER_NEGATIV_2[channel-1] != -1) && (SIGNAL_THRES_UP_NEGATIV_2[channel-1] == -1)) SIGNAL_THRES_UP_NEGATIV_2[channel-1] = cnt ;
                    else if ((LPSIGNAL[cnt] > SIGNAL_THRES_UP[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_OVER_NEGATIV_2[channel-1] != -1) && (SIGNAL_THRES_UP_NEGATIV_2[channel-1] == -1)) SIGNAL_THRES_UP_NEGATIV_2[channel-1] = cnt ;

                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_UP_NEGATIV_2[channel-1] != -1) && (SIGNAL_THRES_MDL_NEGATIV_2[channel-1] == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV_2[channel-1] = cnt ;
                        SIGNAL_THRES_UP_NEGATIV_2[channel-1] = -1;
                    }
                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_UP_NEGATIV_2[channel-1] != -1) && (SIGNAL_THRES_MDL_NEGATIV_2[channel-1] == -1)) SIGNAL_THRES_MDL_NEGATIV_2[channel-1] = cnt ;
                    else if ((LPSIGNAL[cnt] > SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_UP_NEGATIV_2[channel-1] != -1) && (SIGNAL_THRES_MDL_NEGATIV_2[channel-1] == -1)) SIGNAL_THRES_MDL_NEGATIV_2[channel-1] = cnt ;

                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_MDL_NEGATIV_2[channel-1] != -1) && (SIGNAL_THRES_LOW_NEGATIV_2[channel-1] == -1)) SIGNAL_THRES_LOW_NEGATIV_2[channel-1] = cnt ;
                }


                if ((SIGNAL_THRES_UP_POSITIV_1[channel-1] != -1) && (SIGNAL_THRES_UP_POSITIV_2[channel-1] != -1))
                {
                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_PRE_POSITIV = cnt ;
                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_LOW[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_MDL[channel-1]) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt ;
                    else if ((LPSIGNAL[cnt] < SIGNAL_THRES_LOW[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_PRE_POSITIV != -1) && (SIGNAL_THRES_LOW_POSITIV == -1)) SIGNAL_THRES_LOW_POSITIV = cnt ;

                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1))
                    {
                        SIGNAL_THRES_PRE_POSITIV = cnt ;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                    }
                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt ;
                    else if ((LPSIGNAL[cnt] < SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_LOW_POSITIV != -1) && (SIGNAL_THRES_MDL_POSITIV == -1)) SIGNAL_THRES_MDL_POSITIV = cnt ;

                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_MDL_POSITIV != -1) && (SIGNAL_THRES_UP_POSITIV == -1))
                    {
                        SIGNAL_THRES_UP_POSITIV = cnt ;

                        SIGNAL_THRES_PRE_POSITIV_LAST[channel-1] = SIGNAL_THRES_PRE_POSITIV;
                        SIGNAL_THRES_LOW_POSITIV_LAST[channel-1] = SIGNAL_THRES_LOW_POSITIV;
                        SIGNAL_THRES_MDL_POSITIV_LAST[channel-1] = SIGNAL_THRES_MDL_POSITIV;
                        SIGNAL_THRES_UP_POSITIV_LAST[channel-1] = SIGNAL_THRES_UP_POSITIV;
                        SIGNAL_THRES_OVER_POSITIV_LAST[channel-1] = SIGNAL_THRES_OVER_POSITIV;

                        SIGNAL_THRES_PRE_POSITIV = -1;
                        SIGNAL_THRES_LOW_POSITIV = -1;
                        SIGNAL_THRES_MDL_POSITIV = -1;
                        SIGNAL_THRES_UP_POSITIV = -1;
                        SIGNAL_THRES_OVER_POSITIV = -1;
                    }
                }


                if ((SIGNAL_THRES_LOW_NEGATIV_1[channel-1] != -1) && (SIGNAL_THRES_LOW_NEGATIV_2[channel-1] != -1))
                {
                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_OVER_NEGATIV = cnt ;
                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_UP[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_MDL[channel-1]) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt ;
                    else if ((LPSIGNAL[cnt] > SIGNAL_THRES_UP[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_OVER_NEGATIV != -1) && (SIGNAL_THRES_UP_NEGATIV == -1)) SIGNAL_THRES_UP_NEGATIV = cnt ;

                    if ((LPSIGNAL[cnt] < SIGNAL_THRES_UP[channel-1]) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1))
                    {
                        SIGNAL_THRES_OVER_NEGATIV = cnt ;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                    }
                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] < SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt ;
                    else if ((LPSIGNAL[cnt] > SIGNAL_THRES_MDL[channel-1]) && (LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_UP_NEGATIV != -1) && (SIGNAL_THRES_MDL_NEGATIV == -1)) SIGNAL_THRES_MDL_NEGATIV = cnt ;

                    if ((LPSIGNAL[cnt] > SIGNAL_THRES_LOW[channel-1]) && (SIGNAL_THRES_MDL_NEGATIV != -1) && (SIGNAL_THRES_LOW_NEGATIV == -1))
                    {
                        SIGNAL_THRES_LOW_NEGATIV = cnt ;

                        SIGNAL_THRES_PRE_NEGATIV_LAST[channel-1] = SIGNAL_THRES_PRE_NEGATIV;
                        SIGNAL_THRES_LOW_NEGATIV_LAST[channel-1] = SIGNAL_THRES_LOW_NEGATIV;
                        SIGNAL_THRES_MDL_NEGATIV_LAST[channel-1] = SIGNAL_THRES_MDL_NEGATIV;
                        SIGNAL_THRES_UP_NEGATIV_LAST[channel-1] = SIGNAL_THRES_UP_NEGATIV;
                        SIGNAL_THRES_OVER_NEGATIV_LAST[channel-1] = SIGNAL_THRES_OVER_NEGATIV;

                        SIGNAL_THRES_PRE_NEGATIV = -1;
                        SIGNAL_THRES_LOW_NEGATIV = -1;
                        SIGNAL_THRES_MDL_NEGATIV = -1;
                        SIGNAL_THRES_UP_NEGATIV = -1;
                        SIGNAL_THRES_OVER_NEGATIV = -1;
                    }
                }

                /*if ((SIGNAL_THRES_UP_POSITIV_2[channel-1] != -1) && (SIGNAL_THRES_LOW_NEGATIV_2[channel-1] != -1))
                {
                    break;
                } */
            }

            if (SIGNAL_THRES_PRE_POSITIV_LAST[channel-1] == -1) SIGNAL_THRES_PRE_POSITIV_LAST[channel-1] = SIGNAL_THRES_PRE_POSITIV_2[channel-1];
            if (SIGNAL_THRES_LOW_POSITIV_LAST[channel-1] == -1) SIGNAL_THRES_LOW_POSITIV_LAST[channel-1] = SIGNAL_THRES_LOW_POSITIV_2[channel-1];
            if (SIGNAL_THRES_MDL_POSITIV_LAST[channel-1] == -1) SIGNAL_THRES_MDL_POSITIV_LAST[channel-1] = SIGNAL_THRES_MDL_POSITIV_2[channel-1];
            if (SIGNAL_THRES_UP_POSITIV_LAST[channel-1] == -1) SIGNAL_THRES_UP_POSITIV_LAST[channel-1] = SIGNAL_THRES_UP_POSITIV_2[channel-1];
            if (SIGNAL_THRES_OVER_POSITIV_LAST[channel-1] == -1) SIGNAL_THRES_OVER_POSITIV_LAST[channel-1] = SIGNAL_THRES_OVER_POSITIV_2[channel-1];

            if (SIGNAL_THRES_PRE_NEGATIV_LAST[channel-1] == -1) SIGNAL_THRES_PRE_NEGATIV_LAST[channel-1] = SIGNAL_THRES_PRE_NEGATIV_2[channel-1];
            if (SIGNAL_THRES_LOW_NEGATIV_LAST[channel-1] == -1) SIGNAL_THRES_LOW_NEGATIV_LAST[channel-1] = SIGNAL_THRES_LOW_NEGATIV_2[channel-1];
            if (SIGNAL_THRES_MDL_NEGATIV_LAST[channel-1] == -1) SIGNAL_THRES_MDL_NEGATIV_LAST[channel-1] = SIGNAL_THRES_MDL_NEGATIV_2[channel-1];
            if (SIGNAL_THRES_UP_NEGATIV_LAST[channel-1] == -1) SIGNAL_THRES_UP_NEGATIV_LAST[channel-1] = SIGNAL_THRES_UP_NEGATIV_2[channel-1];
            if (SIGNAL_THRES_OVER_NEGATIV_LAST[channel-1] == -1) SIGNAL_THRES_OVER_NEGATIV_LAST[channel-1] = SIGNAL_THRES_OVER_NEGATIV_2[channel-1];

#ifdef _Debug_QM_
            if (Debug_Mode)
            {
                printf("1 : ixs %d ixss %d tpud1 %d tpl1 %d tpm1 %d tpu1 %d\n", ixs, ixss, SIGNAL_THRES_PRE_POSITIV_1[channel-1], SIGNAL_THRES_LOW_POSITIV_1[channel-1], SIGNAL_THRES_MDL_POSITIV_1[channel-1], SIGNAL_THRES_UP_POSITIV_1[channel-1]);
                printf("1 : ixs %d ixss %d tnov1 %d tnl1 %d tnm1 %d tnu1 %d \n", ixs, ixss, SIGNAL_THRES_OVER_NEGATIV_1[channel-1], SIGNAL_THRES_LOW_NEGATIV_1[channel-1], SIGNAL_THRES_MDL_NEGATIV_1[channel-1], SIGNAL_THRES_UP_NEGATIV_1[channel-1]);
                printf("1 : ixs %d ixss %d tpud2 %d tpl2 %d tpm2 %d tpu2 %d\n", ixs, ixss, SIGNAL_THRES_PRE_POSITIV_2[channel-1], SIGNAL_THRES_LOW_POSITIV_2[channel-1], SIGNAL_THRES_MDL_POSITIV_2[channel-1], SIGNAL_THRES_UP_POSITIV_2[channel-1]);
                printf("1 : ixs %d ixss %d tnov2 %d tnl2 %d tnm2 %d tnu2 %d \n", ixs, ixss, SIGNAL_THRES_OVER_NEGATIV_2[channel-1], SIGNAL_THRES_LOW_NEGATIV_2[channel-1], SIGNAL_THRES_MDL_NEGATIV_2[channel-1], SIGNAL_THRES_UP_NEGATIV_2[channel-1]);
                printf("1 : ixs %d ixss %d tpovl %d tpll %d tpml %d tpul %d \n", ixs, ixss, SIGNAL_THRES_OVER_POSITIV_LAST[channel-1], SIGNAL_THRES_LOW_POSITIV_LAST[channel-1], SIGNAL_THRES_MDL_POSITIV_LAST[channel-1], SIGNAL_THRES_UP_POSITIV_LAST[channel-1]);
                printf("1 : ixs %d ixss %d tnovl %d tnll %d tnml %d tnul %d \n", ixs, ixss, SIGNAL_THRES_OVER_NEGATIV_LAST[channel-1], SIGNAL_THRES_LOW_NEGATIV_LAST[channel-1], SIGNAL_THRES_MDL_NEGATIV_LAST[channel-1], SIGNAL_THRES_UP_NEGATIV_LAST[channel-1]);
            }
#endif
}	
	}

       
		


   
    QM_V_A_Buf[0] = 0;
    QM_H_A_Buf[0] = 0;

    if (QM_Type[0] > 0)
    {
        BufVal = Measure(0, (char) QM_Channel[0], (char) QM_Type[0], &BufPre[0], &BufUnit[0], &BufReturn[0], &QM_V_A_Buf[0], &QM_H_A_Buf[0]);

        QM_Slot1.Write_Value(BufVal);
        QM_Slot1.Write_Unit(BufUnit);
#ifdef _Debug_QM_
//        printf("qm1 val : %f  unit : %s type : %d\n", BufVal, BufUnit, QM_Type[0]);
#endif

        //if (QM_Type[0] != QM_Type_Old[0])
        {
            QM_Slot1.Write_PreText(BufPre);
        }

        QM_Slot1.RenderText();

        QM_Changed[0] = 1;
    }

    if (QM_Type[1] > 0)
    {
        BufVal = Measure(1, (char) QM_Channel[1], (char) QM_Type[1], &BufPre[0], &BufUnit[0], &BufReturn[0], &QM_V_A_Buf[0], &QM_H_A_Buf[0]);

        QM_Slot2.Write_Value(BufVal);
        QM_Slot2.Write_Unit(BufUnit);

        //if (QM_Type[1] != QM_Type_Old[1])
        {
            QM_Slot2.Write_PreText(BufPre);
        }

        QM_Slot2.RenderText();

        QM_Changed[1] = 1;
    }

    if (QM_Type[2] > 0)
    {
        BufVal = Measure(2, (char) QM_Channel[2], (char) QM_Type[2], &BufPre[0], &BufUnit[0], &BufReturn[0], &QM_V_A_Buf[0], &QM_H_A_Buf[0]);

        QM_Slot3.Write_Value(BufVal);
        QM_Slot3.Write_Unit(BufUnit);

        //if (QM_Type[2] != QM_Type_Old[2])
        {

            QM_Slot3.Write_PreText(BufPre);
        }

        QM_Slot3.RenderText();

        QM_Changed[2] = 1;
    }

    QM_Vertical_Active = QM_V_A_Buf[0];
    QM_Horizontal_Active = QM_H_A_Buf[0];

    Display::DRAW_ALL_CURSOR();
    Display::DRAWQMDATA(0);	

    //rot_int->np_piointerruptmask = 0x01;						
    //key_int->np_piointerruptmask = 0x01;    		
	//#undef _Debug_QM_
}
