#include "hardware_t.h"
#include "tc_vars.h"
#include "flash_t.h"
#include "display_t.h"
//#include "math.h"

// Class Display
//##########################################################################################################################################################

void Display::ClearMenuAsm(long start, long count)
{
    asm(" 	
	         PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	         MOVI	%r3,%lo(0x0095FA00)
	         PFX	%xhi(0x0095FA00)
	         MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
             PFX	%hi(0x00969000)                   ; Set UI2 Address
             MOVI	%r4,%lo(0x00969000)
             PFX	%xhi(0x00969000)
             MOVHI	%r4,%xlo(0x00969000)*/
	
/*	
             PFX	%hi(0x009F5A00)                   ; Set UI2 Address
             MOVI	%r4,%lo(0x009F5A00)
             PFX	%xhi(0x009F5A00)
             MOVHI	%r4,%xlo(0x009F5A00)
*/
             PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
             MOVI	%r4,%lo(0x008D3BF4)
             PFX	%xhi(0x008D3BF4)
             MOVHI	%r4,%xlo(0x008D3BF4)

             PFX	%hi(0x00972600)                   ; Set UI3 Address
             MOVI	%r5,%lo(0x00972600)
             PFX	%xhi(0x00972600)
             MOVHI	%r5,%xlo(0x00972600)	
	
             PFX	%hi(0x0097BC00)                   ; Set UI4 Address
             MOVI	%r6,%lo(0x0097BC00)
             PFX	%xhi(0x0097BC00)
             MOVHI	%r6,%xlo(0x0097BC00)                     	

             PFX	%hi(0x00985200)                   ; Set UI5 Address
             MOVI	%r7,%lo(0x00985200)
             PFX	%xhi(0x00985200)
             MOVHI	%r7,%xlo(0x00985200)	
	
             PFX	%hi(0x009AAA00)                   ; Set CH4 Address
             MOVI	%r8,%lo(0x009AAA00)
             PFX	%xhi(0x009AAA00)
             MOVHI	%r8,%xlo(0x009AAA00)

             ADD    %r3, %i0                          ; Add Address Counter
             ADD    %r4, %i0
             ADD    %r5, %i0
             ADD    %r6, %i0
             ADD    %r7, %i0
             ADD    %r8, %i0

             MOV    %r1, %i1	

             PFX	%hi(0)                            ; Set Clear register
             MOVI	%r2,%lo(0)
             PFX	%xhi(0)
             MOVHI	%r2,%xlo(0)	

             PFX	%hi(0xFFFFFFFF)                            ; Set Clear register
             MOVI	%r9,%lo(0xFFFFFFFF)
             PFX	%xhi(0xFFFFFFFF)
             MOVHI	%r9,%xlo(0xFFFFFFFF)	
	
             loopCM:
             ST     [%r3], %r2                        ; Clear Buffer
             ST     [%r4], %r2                        ; Clear Buffer
             ST     [%r5], %r9                        ; Clear Buffer
             ST     [%r6], %r2                        ; Clear Buffer
             ST     [%r7], %r2                        ; Clear Buffer
             ST     [%r8], %r2                        ; Clear Buffer
                                          	
             ADDI   %r3, 4                            ; Add Address Counter
             ADDI   %r4, 4
             ADDI   %r5, 4
             ADDI   %r6, 4
             ADDI   %r7, 4
             ADDI   %r8, 4	

             SUBI   %r1, 1                            ; Decrement Line Counter
             SKPS   cc_z
             BR     loopCM
             NOP 	
        ");

   // UpdateMenuTextPlane = true;
}
//##########################################################################################################################################################

void Display::ClearMenuItem(int ItemNr)				// Clear a Menuitem            Überarbeiten mit Assembler Funktion
{
	int xa, Ct;
	
	switch(ItemNr)
	{
		case 0:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{			
				*(UI_Plane1 + xa) = 0;
				*(UI_Plane1 + xa + 1) = 0;
				*(UI_Plane1 + xa + 2) = 0;
				*(UI_Plane1 + xa + 3) = *(UI_Plane1 + xa + 3) & 0x0007FFFF;			
				*(Buffer_UI2Plane + xa) = 0;
				*(Buffer_UI2Plane + xa + 1) = 0;
				*(Buffer_UI2Plane + xa + 2) = 0;
				*(Buffer_UI2Plane + xa + 3) = *(Buffer_UI2Plane + xa + 3) & 0x0007FFFF;
				// BF reactivated UI_Plane3
				*(UI_Plane3 + xa) = 0;
				*(UI_Plane3 + xa + 1) = 0;
				*(UI_Plane3 + xa + 2) = 0;
				*(UI_Plane3 + xa + 3) = *(UI_Plane3 + xa + 3) & 0x0007FFFF;
				// BF end
				*(UI_Plane4 + xa) = 0;
				*(UI_Plane4 + xa + 1) = 0;
				*(UI_Plane4 + xa + 2) = 0;
				*(UI_Plane4 + xa + 3) = *(UI_Plane4 + xa + 3) & 0x0007FFFF;
				*(UI_Plane5 + xa) = 0;
				*(UI_Plane5 + xa + 1) = 0;
				*(UI_Plane5 + xa + 2) = 0;
				*(UI_Plane5 + xa + 3) = *(UI_Plane5 + xa + 3) & 0x0007FFFF;
				xa += 20;
			}
			break;
		}
		case 1:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{
				*(UI_Plane1 + xa + 3) = *(UI_Plane1 + xa + 3) & 0xFFFF0000;
				*(UI_Plane1 + xa + 4) = 0;
				*(UI_Plane1 + xa + 5) = 0;
				*(UI_Plane1 + xa + 6) = *(UI_Plane1 + xa + 6) & 0x000003FF;								
				*(Buffer_UI2Plane + xa + 3) = *(Buffer_UI2Plane + xa + 3) & 0xFFFF0000;
				*(Buffer_UI2Plane + xa + 4) = 0;
				*(Buffer_UI2Plane + xa + 5) = 0;
				*(Buffer_UI2Plane + xa + 6) = *(Buffer_UI2Plane + xa + 6) & 0x000003FF;
				// BF reactivated UI_Plane3
				*(UI_Plane3 + xa + 3) = *(UI_Plane3 + xa + 3) & 0xFFFF0000;
				*(UI_Plane3 + xa + 4) = 0;
				*(UI_Plane3 + xa + 5) = 0;
				*(UI_Plane3 + xa + 6) = *(UI_Plane3 + xa + 6) & 0x000003FF;
				// BF end
				*(UI_Plane4 + xa + 3) = *(UI_Plane4 + xa + 3) & 0xFFFF0000;
				*(UI_Plane4 + xa + 4) = 0;
				*(UI_Plane4 + xa + 5) = 0;
				*(UI_Plane4 + xa + 6) = *(UI_Plane4 + xa + 6) & 0x000003FF;
				*(UI_Plane5 + xa + 3) = *(UI_Plane5 + xa + 3) & 0xFFFF0000;
				*(UI_Plane5 + xa + 4) = 0;
				*(UI_Plane5 + xa + 5) = 0;
				*(UI_Plane5 + xa + 6) = *(UI_Plane5 + xa + 6) & 0x000003FF;
				xa += 20;
			}
			break;
		}
		case 2:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{
				*(UI_Plane1 + xa + 6) = *(UI_Plane1 + xa + 6) & 0xFFFFFF00;
				*(UI_Plane1 + xa + 7) = 0;
				*(UI_Plane1 + xa + 8) = 0;
				*(UI_Plane1 + xa + 9) = 0;
				*(Buffer_UI2Plane + xa + 6) = *(Buffer_UI2Plane + xa + 6) & 0xFFFFFF00;
				*(Buffer_UI2Plane + xa + 7) = 0;
				*(Buffer_UI2Plane + xa + 8) = 0;
				*(Buffer_UI2Plane + xa + 9) = 0;	
				// BF reactivated UI_Plane3
				*(UI_Plane3 + xa + 6) = *(UI_Plane3 + xa + 6) & 0xFFFFFF00;
				*(UI_Plane3 + xa + 7) = 0;
				*(UI_Plane3 + xa + 8) = 0;
				*(UI_Plane3 + xa + 9) = 0;
				// BF end
				*(UI_Plane4 + xa + 6) = *(UI_Plane4 + xa + 6) & 0xFFFFFF00;
				*(UI_Plane4 + xa + 7) = 0;
				*(UI_Plane4 + xa + 8) = 0;
				*(UI_Plane4 + xa + 9) = 0;
				*(UI_Plane5 + xa + 6) = *(UI_Plane5 + xa + 6) & 0xFFFFFF00;
				*(UI_Plane5 + xa + 7) = 0;
				*(UI_Plane5 + xa + 8) = 0;
				*(UI_Plane5 + xa + 9) = 0;
				xa += 20;
			}
			break;
		}
		case 3:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{
				*(UI_Plane1 + xa + 10) = 0;
				*(UI_Plane1 + xa + 11) = 0;
				*(UI_Plane1 + xa + 12) = 0;
				*(UI_Plane1 + xa + 13) = *(UI_Plane1 + xa + 13) & 0x00FFFFFF;
				*(Buffer_UI2Plane + xa + 10) = 0;
				*(Buffer_UI2Plane + xa + 11) = 0;
				*(Buffer_UI2Plane + xa + 12) = 0;
				*(Buffer_UI2Plane + xa + 13) = *(Buffer_UI2Plane + xa + 13) & 0x00FFFFFF;
				// BF reactivated UI_Plane3
				*(UI_Plane3 + xa + 10) = 0;
				*(UI_Plane3 + xa + 11) = 0;
				*(UI_Plane3 + xa + 12) = 0;
				*(UI_Plane3 + xa + 13) = *(UI_Plane3 + xa + 13) & 0x00FFFFFF;
				// BF end
				*(UI_Plane4 + xa + 10) = 0;
				*(UI_Plane4 + xa + 11) = 0;
				*(UI_Plane4 + xa + 12) = 0;
				*(UI_Plane4 + xa + 13) = *(UI_Plane4 + xa + 13) & 0x00FFFFFF;
				*(UI_Plane5 + xa + 10) = 0;
				*(UI_Plane5 + xa + 11) = 0;
				*(UI_Plane5 + xa + 12) = 0;
				*(UI_Plane5 + xa + 13) = *(UI_Plane5 + xa + 13) & 0x00FFFFFF;
				xa += 20;
			}
			break;
		}
		case 4:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{
				*(UI_Plane1 + xa + 13) = *(UI_Plane1 + xa + 13) & 0xFF000000;
				*(UI_Plane1 + xa + 14) = 0;
				*(UI_Plane1 + xa + 15) = 0;
				*(UI_Plane1 + xa + 16) =  *(UI_Plane1 + xa + 16) & 0x00007FFF;
				*(Buffer_UI2Plane + xa + 13) = *(Buffer_UI2Plane + xa + 13) & 0xFF000000;
				*(Buffer_UI2Plane + xa + 14) = 0;
				*(Buffer_UI2Plane + xa + 15) = 0;
				*(Buffer_UI2Plane + xa + 16) =  *(Buffer_UI2Plane + xa + 16) & 0x00007FFF;
				// BF reactivated UI_Plane3
				*(UI_Plane3 + xa + 13) = *(UI_Plane3 + xa + 13) & 0xFF000000;
				*(UI_Plane3 + xa + 14) = 0;
				*(UI_Plane3 + xa + 15) = 0;
				*(UI_Plane3 + xa + 16) =  *(UI_Plane3 + xa + 16) & 0x00007FFF;
				// BF end
				*(UI_Plane4 + xa + 13) = *(UI_Plane4 + xa + 13) & 0xFF000000;
				*(UI_Plane4 + xa + 14) = 0;
				*(UI_Plane4 + xa + 15) = 0;
				*(UI_Plane4 + xa + 16) =  *(UI_Plane4 + xa + 16) & 0x00007FFF;
				*(UI_Plane5 + xa + 13) = *(UI_Plane5 + xa + 13) & 0xFF000000;
				*(UI_Plane5 + xa + 14) = 0;
				*(UI_Plane5 + xa + 15) = 0;
				*(UI_Plane5 + xa + 16) =  *(UI_Plane5 + xa + 16) & 0x00007FFF;
				xa += 20;
			}
			break;
		}
		case 5:
		{
			xa = 432 * 20;

			for (Ct = 0; Ct < 44; Ct++)
			{
				*(UI_Plane1 + xa + 16) = *(UI_Plane1 + xa + 16) & 0xFFFFC000;
				*(UI_Plane1 + xa + 17) = 0;
				*(UI_Plane1 + xa + 18) = 0;
				*(UI_Plane1 + xa + 19) = 0;
				*(Buffer_UI2Plane + xa + 16) = *(Buffer_UI2Plane + xa + 16) & 0xFFFFC000;
				*(Buffer_UI2Plane + xa + 17) = 0;
				*(Buffer_UI2Plane + xa + 18) = 0;
				*(Buffer_UI2Plane + xa + 19) = 0;
				// BF reactivated UI_Plane3
				*(UI_Plane3 + xa + 16) = *(UI_Plane3 + xa + 16) & 0xFFFFC000;
				*(UI_Plane3 + xa + 17) = 0;
				*(UI_Plane3 + xa + 18) = 0;
				*(UI_Plane3 + xa + 19) = 0;
				// BF end
				*(UI_Plane4 + xa + 16) = *(UI_Plane4 + xa + 16) & 0xFFFFC000;
				*(UI_Plane4 + xa + 17) = 0;
				*(UI_Plane4 + xa + 18) = 0;
				*(UI_Plane4 + xa + 19) = 0;
				*(UI_Plane5 + xa + 16) = *(UI_Plane5 + xa + 16) & 0xFFFFC000;
				*(UI_Plane5 + xa + 17) = 0;
				*(UI_Plane5 + xa + 18) = 0;
				*(UI_Plane5 + xa + 19) = 0;
				xa += 20;
			}
			break;
		}
	}	
 //   UpdateMenuTextPlane = true;								
}
//##########################################################################################################################################################

void Display::ClearMenuItemAsm(long which, long start, long count)
{
    switch(which)
    {
        case 0 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0x0001FFFF)                   ; Set MASK
                     MOVI	%r10,%lo(0x0001FFFF)
                     PFX	%xhi(0x0001FFFF)
                     MOVHI	%r10,%xlo(0x0001FFFF)

                     PFX	%hi(0xFFFE0000)                   ; Set MASK
                     MOVI	%r11,%lo(0xFFFE0000)
                     PFX	%xhi(0xFFFE0000)
                     MOVHI	%r11,%xlo(0xFFFE0000)   	


                     loopCMI0:

                     ;// UI 1
                     MOV    %L0, %r3

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     ST     [%L0], %r9                        ; Clear Buffer
                     STP    [%L0, 1], %r9                     ; Clear Buffer
                     STP    [%L0, 2], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 4
                     MOV    %L0, %r6

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI0
                     NOP 	
                ");
            break;
        }

        case 1 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
	
/*
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)

                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFF0000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFF0000)
                     PFX	%xhi(0xFFFF0000)
                     MOVHI	%r10,%xlo(0xFFFF0000)

                     PFX	%hi(0x0000FFFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x0000FFFF)
                     PFX	%xhi(0x0000FFFF)
                     MOVHI	%r11,%xlo(0x0000FFFF)             	

                     PFX	%hi(0x000003FF)                   ; Set MASK
                     MOVI	%r12,%lo(0x000003FF)
                     PFX	%xhi(0x000003FF)
                     MOVHI	%r12,%xlo(0x000003FF)

                     PFX	%hi(0xFFFFFC00)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFFFC00)
                     PFX	%xhi(0xFFFFFC00)
                     MOVHI	%r13,%xlo(0xFFFFFC00)             	
	
                     loopCMI1:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back

                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r9                     ; Clear Buffer
                     STP    [%L0, 5], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI1
                     NOP 	
                 ");
            break;
        }

        case 2 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFFFF80)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFFFF80)
                     PFX	%xhi(0xFFFFFF80)
                     MOVHI	%r10,%xlo(0xFFFFFF80)

                     PFX	%hi(0x0000007F)                   ; Set MASK
                     MOVI	%r11,%lo(0x0000007F)
                     PFX	%xhi(0x0000007F)
                     MOVHI	%r11,%xlo(0x0000007F)             	

                     loopCMI2:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer
                     STP    [%L0, 9], %r2                     ; Clear Buffer


                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer
                     STP    [%L0, 9], %r2                     ; Clear Buffer
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     STP    [%L0, 7], %r9                     ; Clear Buffer
                     STP    [%L0, 8], %r9                     ; Clear Buffer
                     STP    [%L0, 9], %r9                     ; Clear Buffer

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer
                     STP    [%L0, 9], %r2                     ; Clear Buffer
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer
                     STP    [%L0, 9], %r2                     ; Clear Buffer
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer
                     STP    [%L0, 9], %r2                     ; Clear Buffer
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI2
                     NOP 	
                 ");
            break;
        }

        case 3 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0x00FFFFFF)                   ; Set MASK
                     MOVI	%r10,%lo(0x00FFFFFF)
                     PFX	%xhi(0x00FFFFFF)
                     MOVHI	%r10,%xlo(0x00FFFFFF)

                     PFX	%hi(0xFF000000)                   ; Set MASK
                     MOVI	%r11,%lo(0xFF000000)
                     PFX	%xhi(0xFF000000)
                     MOVHI	%r11,%xlo(0xFF000000)             	
	
                     loopCMI3:

                     ;// UI 1
                     MOV    %L0, %r3

                     STP    [%L0, 10], %r2                      ; Clear Buffer
                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     STP    [%L0, 10], %r2                      ; Clear Buffer
                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     STP    [%L0, 10], %r9                      ; Clear Buffer
                     STP    [%L0, 11], %r9                     ; Clear Buffer
                     STP    [%L0, 12], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 4
                     MOV    %L0, %r6

                     STP    [%L0, 10], %r2                      ; Clear Buffer
                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     STP    [%L0, 10], %r2                      ; Clear Buffer
                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     STP    [%L0, 10], %r2                      ; Clear Buffer
                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI3
                     NOP 	
                ");
            break;
        }

        case 4 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFE00000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFE00000)
                     PFX	%xhi(0xFFE00000)
                     MOVHI	%r10,%xlo(0xFFE00000)

                     PFX	%hi(0x001FFFFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x001FFFFF)
                     PFX	%xhi(0x001FFFFF)
                     MOVHI	%r11,%xlo(0x001FFFFF)             	

                     PFX	%hi(0x00007FFF)                   ; Set MASK
                     MOVI	%r12,%lo(0x00007FFF)
                     PFX	%xhi(0x00007FFF)
                     MOVHI	%r12,%xlo(0x00007FFF)

                     PFX	%hi(0xFFFF8000)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFF8000)
                     PFX	%xhi(0xFFFF8000)
                     MOVHI	%r13,%xlo(0xFFFF8000)             	
	
                     loopCMI4:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back

                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r9                    ; Clear Buffer
                     STP    [%L0, 15], %r9                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI4
                     NOP 	
                 ");

            break;
        }

        case 5 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFFF000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFFF000)
                     PFX	%xhi(0xFFFFF000)
                     MOVHI	%r10,%xlo(0xFFFFF000)

                     PFX	%hi(0x00000FFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x00000FFF)
                     PFX	%xhi(0x00000FFF)
                     MOVHI	%r11,%xlo(0x00000FFF)             	

                     loopCMI5:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer
                     STP    [%L0, 19], %r2                    ; Clear Buffer


                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer
                     STP    [%L0, 19], %r2                    ; Clear Buffer
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     STP    [%L0, 17], %r9                    ; Clear Buffer
                     STP    [%L0, 18], %r9                    ; Clear Buffer
                     STP    [%L0, 19], %r9                    ; Clear Buffer

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer
                     STP    [%L0, 19], %r2                    ; Clear Buffer
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer
                     STP    [%L0, 19], %r2                    ; Clear Buffer
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
                     STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer
                     STP    [%L0, 19], %r2                    ; Clear Buffer
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMI5
                     NOP 	
                 ");
            break;
        }
    }
    //UpdateMenuTextPlane = true;
}
//##########################################################################################################################################################

void Display::ClearMenuItemTextAsm(long which, long start, long count)
{
    switch(which)
    {
        case 0 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFC00000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFC00000)
                     PFX	%xhi(0xFFC00000)
                     MOVHI	%r10,%xlo(0xFFC00000)

                     PFX	%hi(0x003FFFFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x003FFFFF)
                     PFX	%xhi(0x003FFFFF)
                     MOVHI	%r11,%xlo(0x003FFFFF)

                     PFX	%hi(0x003FFFFF)                   ; Set MASK
                     MOVI	%r12,%lo(0x003FFFFF)
                     PFX	%xhi(0x003FFFFF)
                     MOVHI	%r12,%xlo(0x003FFFFF)

                     PFX	%hi(0xFFC00000)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFC00000)
                     PFX	%xhi(0xFFC00000)
                     MOVHI	%r13,%xlo(0xFFC00000)                                	
	
                     loopCMIT0:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 0]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 0], %r0                     ; Store it back

                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 0]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 0], %r0                     ; Store it back

                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 0]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 0], %r0                     ; Store it back


                     STP    [%L0, 1], %r9                     ; Clear Buffer
                     STP    [%L0, 2], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
 	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 4
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 0]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 0], %r0                     ; Store it back

                     STP    [%L0, 1], %r9                     ; Clear Buffer
                     STP    [%L0, 2], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
                     STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 0]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 0], %r0                     ; Store it back

                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     ST     [%L0], %r2                        ; Clear Buffer
                     STP    [%L0, 1], %r2                     ; Clear Buffer
                     STP    [%L0, 2], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT0
                     NOP 	
                ");
            break;
        }

        case 1 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFFE000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFFE000)
                     PFX	%xhi(0xFFFFE000)
                     MOVHI	%r10,%xlo(0xFFFFE000)

                     PFX	%hi(0x00001FFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x00001FFF)
                     PFX	%xhi(0x00001FFF)
                     MOVHI	%r11,%xlo(0x00001FFF)             	

                     PFX	%hi(0x00001FFF)                   ; Set MASK
                     MOVI	%r12,%lo(0x00001FFF)
                     PFX	%xhi(0x00001FFF)
                     MOVHI	%r12,%xlo(0x00001FFF)

                     PFX	%hi(0xFFFFE000)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFFE000)
                     PFX	%xhi(0xFFFFE000)
                     MOVHI	%r13,%xlo(0xFFFFE000)             	
	
                     loopCMIT1:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back

                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r9                     ; Clear Buffer
                     STP    [%L0, 5], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r9                     ; Clear Buffer
                     STP    [%L0, 5], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 3]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 3], %r0                     ; Store it back
	
                     STP    [%L0, 4], %r2                     ; Clear Buffer
                     STP    [%L0, 5], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT1
                     NOP 	
                 ");
            break;
        }

        case 2 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFFFFE0)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFFFFE0)
                     PFX	%xhi(0xFFFFFFE0)
                     MOVHI	%r10,%xlo(0xFFFFFFE0)

                     PFX	%hi(0x0000001F)                   ; Set MASK
                     MOVI	%r11,%lo(0x0000001F)
                     PFX	%xhi(0x0000001F)
                     MOVHI	%r11,%xlo(0x0000001F)

                     PFX	%hi(0x0000000F)                   ; Set MASK
                     MOVI	%r12,%lo(0x0000000F)
                     PFX	%xhi(0x0000000F)
                     MOVHI	%r12,%xlo(0x0000000F)

                     PFX	%hi(0xFFFFFFF0)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFFFFF0)
                     PFX	%xhi(0xFFFFFFF0)
                     MOVHI	%r13,%xlo(0xFFFFFFF0)                                	

                     loopCMIT2:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back
	
                     STP    [%L0, 7], %r9                     ; Clear Buffer
                     STP    [%L0, 8], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back


                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r9                     ; Clear Buffer
                     STP    [%L0, 8], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back

	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back

	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 6]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 6], %r0                     ; Store it back

                     STP    [%L0, 7], %r2                     ; Clear Buffer
                     STP    [%L0, 8], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 9]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 9], %r0                     ; Store it back

	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT2
                     NOP 	
                 ");
            break;
        }

        case 3 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xF1000000)                   ; Set MASK
                     MOVI	%r10,%lo(0xF1000000)
                     PFX	%xhi(0xF1000000)
                     MOVHI	%r10,%xlo(0xF1000000)

                     PFX	%hi(0x07FFFFFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x07FFFFFF)
                     PFX	%xhi(0x07FFFFFF)
                     MOVHI	%r11,%xlo(0x07FFFFFF)

                     PFX	%hi(0x07FFFFFF)                   ; Set MASK
                     MOVI	%r12,%lo(0x07FFFFFF)
                     PFX	%xhi(0x07FFFFFF)
                     MOVHI	%r12,%xlo(0x07FFFFFF)

                     PFX	%hi(0xF8000000)                   ; Set MASK
                     MOVI	%r13,%lo(0xF8000000)
                     PFX	%xhi(0xF8000000)
                     MOVHI	%r13,%xlo(0xF8000000)                                 	
	
                     loopCMIT3:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r9                     ; Clear Buffer
                     STP    [%L0, 12], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 4
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r9                     ; Clear Buffer
                     STP    [%L0, 12], %r9                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 10]                     ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 10], %r0                     ; Store it back

                     STP    [%L0, 11], %r2                     ; Clear Buffer
                     STP    [%L0, 12], %r2                     ; Clear Buffer

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT3
                     NOP 	
                ");
            break;
        }

        case 4 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFE00000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFE00000)
                     PFX	%xhi(0xFFE00000)
                     MOVHI	%r10,%xlo(0xFFE00000)

                     PFX	%hi(0x001FFFFF)                   ; Set MASK
                     MOVI	%r11,%lo(0x001FFFFF)
                     PFX	%xhi(0x001FFFFF)
                     MOVHI	%r11,%xlo(0x001FFFFF)             	

                     PFX	%hi(0x0003FFFF)                   ; Set MASK
                     MOVI	%r12,%lo(0x0003FFFF)
                     PFX	%xhi(0x0003FFFF)
                     MOVHI	%r12,%xlo(0x0003FFFF)

                     PFX	%hi(0xFFFC0000)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFC0000)
                     PFX	%xhi(0xFFFC0000)
                     MOVHI	%r13,%xlo(0xFFFC0000)             	
	
                     loopCMIT4:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back

                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r9                    ; Clear Buffer
                     STP    [%L0, 15], %r9                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r9                    ; Clear Buffer
                     STP    [%L0, 15], %r9                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 13]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 13], %r0                    ; Store it back
	
                     STP    [%L0, 14], %r2                    ; Clear Buffer
                     STP    [%L0, 15], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT4
                     NOP 	
                 ");

            break;
        }

        case 5 :
        {
            asm(" 	
	                 PFX	%hi(0x0095FA00)                   ; Set UI1 Address
	                 MOVI	%r3,%lo(0x0095FA00)
	                 PFX	%xhi(0x0095FA00)
	                 MOVHI	%r3,%xlo(0x0095FA00)	
	                                              /*
	                 PFX	%hi(0x00969000)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x00969000)
	                 PFX	%xhi(0x00969000)
	                 MOVHI	%r4,%xlo(0x00969000)*/
/*	
	                 PFX	%hi(0x009F5A00)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x009F5A00)
	                 PFX	%xhi(0x009F5A00)
	                 MOVHI	%r4,%xlo(0x009F5A00)	
*/
	                 PFX	%hi(0x008D3BF4)                   ; Set UI2 Address
	                 MOVI	%r4,%lo(0x008D3BF4)
	                 PFX	%xhi(0x008D3BF4)
	                 MOVHI	%r4,%xlo(0x008D3BF4)
	
                     PFX	%hi(0x00972600)                   ; Set UI3 Address
                     MOVI	%r5,%lo(0x00972600)
                     PFX	%xhi(0x00972600)
                     MOVHI	%r5,%xlo(0x00972600)	
	
                     PFX	%hi(0x0097BC00)                   ; Set UI4 Address
                     MOVI	%r6,%lo(0x0097BC00)
                     PFX	%xhi(0x0097BC00)
                     MOVHI	%r6,%xlo(0x0097BC00)                     	

                     PFX	%hi(0x00985200)                   ; Set UI5 Address
                     MOVI	%r7,%lo(0x00985200)
                     PFX	%xhi(0x00985200)
                     MOVHI	%r7,%xlo(0x00985200)	
	
                     PFX	%hi(0x009AAA00)                   ; Set CH4 Address
                     MOVI	%r8,%lo(0x009AAA00)
                     PFX	%xhi(0x009AAA00)
                     MOVHI	%r8,%xlo(0x009AAA00)

                     ADD    %r3, %i1                          ; Add Address Counter
                     ADD    %r4, %i1
                     ADD    %r5, %i1
                     ADD    %r6, %i1
                     ADD    %r7, %i1
                     ADD    %r8, %i1

                     MOV    %r1, %i2

                     PFX	%hi(0)                            ; Set Clear register
                     MOVI	%r2,%lo(0)
                     PFX	%xhi(0)
                     MOVHI	%r2,%xlo(0)	

                     PFX	%hi(0xFFFFFFFF)                   ; Set Clear register
                     MOVI	%r9,%lo(0xFFFFFFFF)
                     PFX	%xhi(0xFFFFFFFF)
                     MOVHI	%r9,%xlo(0xFFFFFFFF)	

                     PFX	%hi(0xFFFFC000)                   ; Set MASK
                     MOVI	%r10,%lo(0xFFFFC000)
                     PFX	%xhi(0xFFFFC000)
                     MOVHI	%r10,%xlo(0xFFFFC000)

                     PFX	%hi(0x000003FF)                   ; Set MASK
                     MOVI	%r11,%lo(0x000003FF)
                     PFX	%xhi(0x000003FF)
                     MOVHI	%r11,%xlo(0x000003FF)

                     PFX	%hi(0x000001FF)                   ; Set MASK
                     MOVI	%r12,%lo(0x000001FF)
                     PFX	%xhi(0x000001FF)
                     MOVHI	%r12,%xlo(0x000001FF)

                     PFX	%hi(0xFFFFFE00)                   ; Set MASK
                     MOVI	%r13,%lo(0xFFFFFE00)
                     PFX	%xhi(0xFFFFFE00)
                     MOVHI	%r13,%xlo(0xFFFFFE00)                                  	

                     loopCMIT5:

                     ;// UI 1
                     MOV    %L0, %r3

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back

                     ;// UI 2
                     MOV    %L0, %r4

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back
	
                     ;// UI 3
                     MOV    %L0, %r5

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back
	
                     STP    [%L0, 17], %r9                    ; Clear Buffer
                     STP    [%L0, 18], %r9                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back

                     ;// UI  4	
                     MOV    %L0, %r6

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r11                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r9                    ; Clear Buffer
                     STP    [%L0, 18], %r9                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     OR     %r0, %r13                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back
	
                     ;// UI 5
                     MOV    %L0, %r7

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back
	
                     ;// CH 4
                     MOV    %L0, %r8

                     LDP    %r0, [%L0, 16]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r10                         ; Mask Data
	                 STP    [%L0, 16], %r0                    ; Store it back

                     STP    [%L0, 17], %r2                    ; Clear Buffer
                     STP    [%L0, 18], %r2                    ; Clear Buffer

                     LDP    %r0, [%L0, 19]                    ; Load Buffer Data to %r0  	
                     AND    %r0, %r12                         ; Mask Data
	                 STP    [%L0, 19], %r0                    ; Store it back
	

                     PFX	%hi(80)                                          	
                     ADDI   %r3, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r4, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r5, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r6, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r7, %lo(80)                      ; Add Address Counter
                     PFX	%hi(80)                                          	
                     ADDI   %r8, %lo(80)                      ; Add Address Counter

                     SUBI   %r1, 1                            ; Decrement Line Counter
                     SKPS   cc_z
                     BR     loopCMIT5
                     NOP 	
                 ");
            break;
        }
    }
   // UpdateMenuTextPlane = true;
}
//##########################################################################################################################################################

void Display::DrawMenuArrow(int posx, int updn, int active)					// Draw Sub-Menu Arrow
{	
	if (updn == 0)  // Down
	{
		BITBITMAP(bitbmBigArrowDown, posx, 455, active, Buffer_UI2Plane);
		BITBITMAP(bitbmBigArrowDown, posx, 455, !active, UI_Plane5);
	}
	else			// Up , it is always displayed without Text -> 10 Dots heigher
	{
		BITBITMAP(bitbmBigArrowUp, posx, 445, active, Buffer_UI2Plane);
		BITBITMAP(bitbmBigArrowUp, posx, 445, !active, UI_Plane5);
	}	
	UpdateMenuTextPlane = true;
}
//##########################################################################################################################################################

void Display::DrawMenuArrowCycle(int posx, int active)						// Draw the knob turn cycle
{
	if (active)
	{
		BITBITMAP(bitbmCycleArrow, posx, 438, 1, Channel_Plane4);
		BITBITMAP(bitbmCycleArrow, posx, 438, 1, Buffer_Plane4);
		BITBITMAP(bitbmCycleArrow, posx, 438, 0, UI_Plane3);
		BITBITMAP(bitbmCycleArrow, posx, 438, 0, UI_Plane4);		
	}
	else BITBITMAP(bitbmCycleArrow, posx, 438, 1, UI_Plane5);
}
//##########################################################################################################################################################

void Display::DrawMenuArrowCycle2(int posx, int active)						// Draw the knob turn cycle
{
	if (active)
	{
		BITBITMAP(bitbmCycleArrow, posx, 455, 1, Channel_Plane4);
		BITBITMAP(bitbmCycleArrow, posx, 455, 1, Buffer_Plane4);
		BITBITMAP(bitbmCycleArrow, posx, 455, 0, UI_Plane3);
		BITBITMAP(bitbmCycleArrow, posx, 455, 0, UI_Plane4);		
	}
	else BITBITMAP(bitbmCycleArrow, posx, 455, 1, UI_Plane5);
}
//##########################################################################################################################################################

void Display::DrawMenuBiggerArrowCycle(int posx, int active)					// Draw the knob turn cycle with popup arrow
{
	if (active)
	{
		BITBITMAP(bitbmSelectCycleArrow, posx, 438, 1, Channel_Plane4);
		BITBITMAP(bitbmSelectCycleArrow, posx, 438, 1, Buffer_Plane4);
		BITBITMAP(bitbmSelectCycleArrow, posx, 438, 0, UI_Plane3);
		BITBITMAP(bitbmSelectCycleArrow, posx, 438, 0, UI_Plane4);
	}
	else BITBITMAP(bitbmSelectCycleArrow, posx, 438, 1, UI_Plane5);
}
//##########################################################################################################################################################

void Display::DrawSubMenuArrow(int posx, int active)						// Draw the sub menu arrow
{
	if (active)  BITBITMAP(bitbmSubMenu, posx, 458, 1, Buffer_UI2Plane);
	else BITBITMAP(bitbmSubMenu, posx, 458, 1, UI_Plane5);
	UpdateMenuTextPlane = true;
}
//##########################################################################################################################################################

//##########################################################################################################################################################

void Display::DrawMenuCheckBox(int posx, int posy, char checked, char active)			// Draw a Checkbox in menu
{
	if (checked)
	{	
		DRAWLINEP(posx, posy, posx + 10, posy, 1, UI_Plane5);
		DRAWLINEP(posx + 1, posy + 10, posx + 11, posy + 10, 1, UI_Plane1);
		DRAWLINEP(posx, posy + 1, posx, posy + 10, 1, UI_Plane5);				
		DRAWLINEP(posx + 10, posy, posx + 10, posy + 10, 1, UI_Plane1);
		
		if (active) DRAWP(posx + 2, posy + 2, 7, 7, 1, Buffer_UI2Plane);								// Checkbox Filling Black
		else
		{
			DRAWP(posx + 2, posy + 2, 7, 7, 1, UI_Plane5);										// Checkbox Filling Gray
		}
	}
	else
	{
		DRAWLINEP(posx, posy, posx + 10, posy, 1, UI_Plane1);	
		DRAWLINEP(posx + 1, posy + 10, posx + 11, posy + 10, 1, UI_Plane5);
		DRAWLINEP(posx, posy + 1, posx, posy + 10, 1, UI_Plane1);		
		DRAWLINEP(posx + 10, posy, posx + 10, posy + 10, 1, UI_Plane5);					
		
		DRAWP(posx + 2, posy + 2, 7, 7, 0, Buffer_UI2Plane);								// Checkbox Filling
		DRAWP(posx + 2, posy + 2, 7, 7, 0, UI_Plane5);								// Checkbox Filling

	}	
    UpdateMenuTextPlane = true;		
}
//##########################################################################################################################################################

void Display::DrawMenuItem(int MenuNr,int ItemNr, unsigned char active, unsigned char pushed)
{
	int ispacer = 0;
	int xe, textcorr = 0;
	char BufferText[17];	
	char BufferText2[17];	
	
	//if ((MenuNr == 15) && (ItemNr == 1)) return; // For Pulse Width button 1 remove
	
	// Get Menuitem Pos
	switch(ItemNr)
	{
		case 0:
		{
			ispacer = 8;
			break;
		}
		case 1:
		{
			ispacer = 113;
			break;
		}
		case 2:
		{
			ispacer = 218;
			break;
		}
		case 3:
		{
			ispacer = 323;
			break;
		}
		case 4:
		{
			ispacer = 428;
			break;
		}
		case 5:
		{
			ispacer = 533;
			break;
		}
	}	
	
	
	
	// Get the Items Caption Text	
	for (xe = 0; xe < 16; xe++)
	{
        	if ((MenuNr == 15) && (ItemNr == 3) && (MenuStatus[15][2] == 3)) BufferText[xe] = MenuItem[MenuNr][ItemNr + 1][xe]; //change items
		else if ((MenuNr == 15) && (ItemNr == 4) && (MenuStatus[15][2] == 3)) BufferText[xe] = MenuItem[MenuNr][ItemNr + 1][xe]; // delta t
		//else if ((MenuNr == 15) && (ItemNr == 1)) BufferText[xe] = MenuItem151[xe]; // delta t		
		else BufferText[xe] = MenuItem[MenuNr][ItemNr][xe];
	}
	
	if ((MenuStatus[MenuNr][ItemNr] > 243) && (MenuStatus[MenuNr][ItemNr] < 247))
	{
		// Draw Items Caption Text
		TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5);		// Draw Menu Text		
		TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane);	// Draw Menu Text	
	}
	else
	{	
	
	    //if ((MenuNr == 15) && (ItemNr == 1)) TEXTOUTxvbig(BufferText, ispacer + 22, 438, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
	    //else
        if ((MenuNr == 15) && ((ItemNr == 3) || (ItemNr == 4)))
        {
            if (ItemNr == 3)
            {
                if (MenuStatus[15][2] == 1)
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5); 	// Draw Menu Data Text
                }
                else if (MenuStatus[15][2] == 2)
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, Buffer_UI2Plane); 	// Draw Menu Data Text
                }
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1))
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, Buffer_UI2Plane); 	// Draw Menu Data Text			
                }
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2))
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5); 	// Draw Menu Data Text
                }
            }

            if (ItemNr == 4)
            {
                if (MenuStatus[15][2] == 2)
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5); 	// Draw Menu Data Text
                }
                else if (MenuStatus[15][2] == 1)
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, Buffer_UI2Plane); 	// Draw Menu Data Text
                }
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2))
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, Buffer_UI2Plane); 	// Draw Menu Data Text	
                }
                else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1))
                {
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
                    TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5); 	// Draw Menu Data Text
                }
            }
        }
        else
        {	
            if (active)
            {
                // Draw Items Caption Text	
                TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, Buffer_UI2Plane);	// Draw Menu Text	
            }
            else
            {
                // Draw Items Caption Text
                TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 1, UI_Plane5);		// Draw Menu Text		
                TEXTOUTxvbig(BufferText, ispacer + MenuItemDef[MenuNr][ItemNr], 438, 0, Buffer_UI2Plane);	// Draw Menu Text
            }
        }
    }
	
	switch(MenuNr)
	{
		// Acquire
		//case 0:
		//{
			//if (ItemNr == 2) DrawMenuArrowCycle(ispacer + 6, active);	//Button 3
			//break;
		//}
		
		// Channels Probe
		case 1:
		case 2:
		case 3:
		case 4:						
		{
			if (ItemNr == 3) DrawMenuArrowCycle(ispacer + 6, active);	
			break;
		}	
		
		// Display
		case 5:
		{
			if (ItemNr == 2) DrawMenuArrowCycle(ispacer + 6, active);	
			break;
		}	
		
		// Save / Recall
		case 8:
		{
			if (ItemNr == 0)
            {
                DrawMenuArrowCycle(ispacer + 6, active);
                sprintf(BufferText, "%d", SavePointer);		
                TEXTOUTxvbig(BufferText, ispacer + 46, 455, 1, Buffer_UI2Plane);					// Draw memory Text
			}
            	
			break;
		}		

		// Trigger Mode
		case 12:
		{
			if (ItemNr == 3)
			{
				if (EdgeToggle == 0) DrawMenuArrowCycle(ispacer + 6, active);
				else DrawMenuArrowCycle(ispacer + 6, 0);
				
                if (HoldOff_Value) TEXTOUTxvbig(HoldOff.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text	
				else TEXTOUTxvbig(MenuData[5], ispacer + 36, 455, 1, Buffer_UI2Plane); 		// Draw Menu Data Text	
				
				// grayed "off"
				//TEXTOUTxvbig(MenuData[5], ispacer + 36, 455, 0, Buffer_UI2Plane);
				//TEXTOUTxvbig(MenuData[5], ispacer + 36, 455, 1, UI_Plane5);
			}
			if (ItemNr == 4)
			{
				if (EdgeToggle == 1) DrawMenuArrowCycle(ispacer + 6, active);
				else DrawMenuArrowCycle(ispacer + 6, 0);
			}			
			break;
		}
		
		// Trigger Edge PreTrigger
		case 14:
		{
			if (ItemNr == 4)
            {
                DrawMenuArrowCycle(ispacer + 6, active);	
                TEXTOUTxvbig(Trigger_Offset_Str.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text	
            }
			break;
		}
        			
		// Pulse Width
		case 15:
		{		
			if (ItemNr == 3)
			{
				if (MenuStatus[15][2] == 1) DrawMenuArrowCycle(ispacer + 6, 0);
				else if (MenuStatus[15][2] == 2) DrawMenuArrowCycle(ispacer + 6, active);
				else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1)) DrawMenuArrowCycle(ispacer + 6, active);			
				else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2)) DrawMenuArrowCycle(ispacer + 6, 0);
			}

			if (ItemNr == 4)
			{
				if (MenuStatus[15][2] == 2)
				DrawMenuArrowCycle(ispacer + 6, 0);
				else if (MenuStatus[15][2] == 1) DrawMenuArrowCycle(ispacer + 6, active);
				else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2)) DrawMenuArrowCycle(ispacer + 6, active);			
				else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1)) DrawMenuArrowCycle(ispacer + 6, 0);
			}            			

			if (MenuStatus[15][2] != 3)
			{
				if (ItemNr == 3)
				{
					if (MenuStatus[15][2] == 1)
					{
						TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
						TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 1, UI_Plane5); 	// Draw Menu Data Text
					}
					else if (MenuStatus[15][2] == 2)
					{
						TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text
					}
					else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1))
					{
						TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text			
					}
					else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2))
					{
						TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
						TEXTOUTxvbig(Pulse21.Read_Text(), ispacer + 26, 455, 1, UI_Plane5); 	// Draw Menu Data Text
					}
               			 }

				if (ItemNr == 4)
				{
					if (MenuStatus[15][2] == 2)
					{
						TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
						TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 1, UI_Plane5); 	// Draw Menu Data Text
					}
					else if (MenuStatus[15][2] == 1)
					{
						TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text
					}
					else if ((MenuStatus[15][2] == 3) && (PulseToggle == 2))
					{
						TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane); 	// Draw Menu Data Text			
					}
					else if ((MenuStatus[15][2] == 3) && (PulseToggle == 1))
					{
						TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 0, Buffer_UI2Plane); 	// Draw Menu Data Text
						TEXTOUTxvbig(Pulse22.Read_Text(), ispacer + 26, 455, 1, UI_Plane5); 	// Draw Menu Data Text
					}
                		}

			}
			else
			{
				if (ItemNr == 3)
				{
					TEXTOUTxvbig(Pulse11.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
				}
				if (ItemNr == 4)
				{
					TEXTOUTxvbig(Pulse12.Read_Text(), ispacer + 26, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
				}
			}
			break;
		}	
		//---------------------------------------------------------------------------
		// BF display cursour data -> added new data for FFT
		//---------------------------------------------------------------------------
		case 16:
		{
			switch(ItemNr)
			{
				case 1:
				{
					if (Cursor_Vertical_Active == 1) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (XY_Mode)
					{
						if (active)	
						{
							TEXTOUTxvbig(Cursor_Vertical_Pos_XY_1_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	
						}
						else
						{
							TEXTOUTxvbig(Cursor_Vertical_Pos_XY_1_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(Cursor_Vertical_Pos_XY_1_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	
						}
					}
					else if(FFT_Mode != FFT_OFF)
					{
						if (active)	
						{
							TEXTOUTxvbig(FFT_Cursor_Vertical_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);
						}
						else
						{
							TEXTOUTxvbig(FFT_Cursor_Vertical_Pos_1_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(FFT_Cursor_Vertical_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	
						}
					}
					else	//normal mode
					{
						if (active)	
						{
							TEXTOUTxvbig(Cursor_Vertical_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);
						}
						else
						{
							TEXTOUTxvbig(Cursor_Vertical_Pos_1_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(Cursor_Vertical_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	
						}
					}
					break;
				}
				
				case 2:
				{
					if (Cursor_Vertical_Active == 2) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (XY_Mode)
					{
						if (active)	
						{
							TEXTOUTxvbig(Cursor_Vertical_Pos_XY_2_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	
						}
						else
						{
							TEXTOUTxvbig(Cursor_Vertical_Pos_XY_2_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(Cursor_Vertical_Pos_XY_2_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);
						}					
					}
					else if(FFT_Mode != FFT_OFF)
					{
						if (active)	
						{
							TEXTOUTxvbig(FFT_Cursor_Vertical_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	
						}
						else
						{
							TEXTOUTxvbig(FFT_Cursor_Vertical_Pos_2_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(FFT_Cursor_Vertical_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	
						}
					}
					else	//normal mode
					{
						if (active)	
						{
							TEXTOUTxvbig(Cursor_Vertical_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	
						}
						else
						{
							TEXTOUTxvbig(Cursor_Vertical_Pos_2_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(Cursor_Vertical_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	
						}
					}
					break;
				}

				case 3:
				{
					if (Cursor_Horizontal_Active == 1) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if(FFT_Mode != FFT_OFF)
					{
						if (active)
						{
							TEXTOUTxvbig(FFT_Cursor_Horizontal_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	
						}
						else
						{
							TEXTOUTxvbig(FFT_Cursor_Horizontal_Pos_1_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(FFT_Cursor_Horizontal_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	
						}
					}
					else	//normal mode
					{
						if (active)
						{
							TEXTOUTxvbig(Cursor_Horizontal_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	
						}
						else
						{
							TEXTOUTxvbig(Cursor_Horizontal_Pos_1_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(Cursor_Horizontal_Pos_1_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	
						}
					}
					break;
				}
						
				case 4:
				{
					if (Cursor_Horizontal_Active == 2) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if(FFT_Mode != FFT_OFF)
					{
						if (active)
						{
							TEXTOUTxvbig(FFT_Cursor_Horizontal_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	
						}
						else
						{
							TEXTOUTxvbig(FFT_Cursor_Horizontal_Pos_2_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(FFT_Cursor_Horizontal_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	
						}
					}
					else	//normal mode
					{
						if (active)
						{
							TEXTOUTxvbig(Cursor_Horizontal_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	
						}
						else
						{
							TEXTOUTxvbig(Cursor_Horizontal_Pos_2_Str.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(Cursor_Horizontal_Pos_2_Str.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	
						}
					}
					break;
				}
				
				case 5:
				{
					if (Cursor_Vertical_Active == 4)
					{
						DrawMenuArrowCycle(ispacer + 6, active);
						DrawMenuArrowCycle2(ispacer + 6, 0);
					}
					else if (Cursor_Horizontal_Active == 4)
					{
						DrawMenuArrowCycle(ispacer + 6, 0);
						DrawMenuArrowCycle2(ispacer + 6, active);
					}
					else
					{
						DrawMenuArrowCycle(ispacer + 6, 0);
						DrawMenuArrowCycle2(ispacer + 6, 0);
					}					
				}				
			}
			break;
		}

		// Quick Measure
		case 19:
		{
			if (ItemNr == 1 ) DrawMenuBiggerArrowCycle(ispacer + 6, active);	
			break;
		}
			
		// Quick Measurment Threshold
		case 22:
		{
			if (ItemNr == 2)
			{
				if (Quick_Measure_Threshold_btn_select == 1) DrawMenuArrowCycle(ispacer + 6, active);	
				else DrawMenuArrowCycle(ispacer + 6, 0);	
		
				TEXTOUTxvbig(QM_Threshold_lower.Read_Text(), ispacer + 36, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
			}
					if (ItemNr == 3)
			{
				if (Quick_Measure_Threshold_btn_select == 2) DrawMenuArrowCycle(ispacer + 6, active);	
				else DrawMenuArrowCycle(ispacer + 6, 0);	
		
				TEXTOUTxvbig(QM_Threshold_middle.Read_Text(), ispacer + 36, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
			}
					if (ItemNr == 4)
			{
				if (Quick_Measure_Threshold_btn_select == 3) DrawMenuArrowCycle(ispacer + 6, active);	
				else DrawMenuArrowCycle(ispacer + 6, 0);	
		
				TEXTOUTxvbig(QM_Threshold_upper.Read_Text(), ispacer + 36, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
			}
			break;
		}

//	BF not needed in new FFT -> causes text failure in Window button!!!

		// FFT Settings		
		case 27:		
		{
/*
			if (ItemNr == 1)
			{
				if (FFTToggle == 0)
					DrawMenuArrowCycle(ispacer + 6, active);	
				else 
					DrawMenuArrowCycle(ispacer + 6, 0);	
				
				TEXTOUTxvbig(FFT_Scale_Str.Read_Text(), ispacer + 8, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
			}
			if (ItemNr == 2)
			{
				if (FFTToggle == 1)
					DrawMenuArrowCycle(ispacer + 6, active);	
				else 
					DrawMenuArrowCycle(ispacer + 6, 0);
				
				 TEXTOUTxvbig(FFT_Offset_Str.Read_Text(), ispacer + 10, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text	
			}
*/


			break;
		}	//BF changed end



		// Math Channel Settings
		case 29:
		{
			switch(ItemNr)
			{
				case 0:
				{
					if (MathToggle == 0) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (active)
					{
                        if (MenuStatus[26][2] == 1)	TEXTOUTxvbig(MenuData[math_mul_scale], ispacer + MenuDataDef[math_mul_scale], 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][3] == 1) TEXTOUTxvbig(MenuData[math_sub_scale], ispacer + MenuDataDef[math_sub_scale], 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][4] == 1) TEXTOUTxvbig(MenuData[math_add_scale], ispacer + MenuDataDef[math_add_scale], 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
					}
					else
					{
						if (MenuStatus[26][2] == 1)	
						{
							TEXTOUTxvbig(MenuData[math_mul_scale], ispacer + 16, 455, 0, Buffer_UI2Plane);
							TEXTOUTxvbig(MenuData[math_mul_scale], ispacer + 16, 455, 1, UI_Plane5);	
						}
						else if (MenuStatus[26][3] == 1)	
						{
							TEXTOUTxvbig(MenuData[math_sub_scale], ispacer + 16, 455, 0, Buffer_UI2Plane);
							TEXTOUTxvbig(MenuData[math_sub_scale], ispacer + 16, 455, 1, UI_Plane5);	
						}
						else if (MenuStatus[26][4] == 1)	
						{
							TEXTOUTxvbig(MenuData[math_add_scale], ispacer + 16, 455, 0, Buffer_UI2Plane);	
							TEXTOUTxvbig(MenuData[math_add_scale], ispacer + 16, 455, 1, UI_Plane5);
						}
					}

					break;
				}			
			
				case 1:
				{
					if (MathToggle == 1) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (active)
					{
                        if (MenuStatus[26][2] == 1)	TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][3] == 1) TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][4] == 1) TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 16, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
					}
					else
					{
                        if (MenuStatus[26][2] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
                        else if (MenuStatus[26][3] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
                        else if (MenuStatus[26][4] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 16, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 16, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
					}

					break;
				}
				
				case 2:
				{
					if (1 == 0) DrawMenuArrowCycle(ispacer + 6, active);
					else DrawMenuArrowCycle(ispacer + 6, 0);
					
					if (active)
					{
                        if (MenuStatus[26][2] == 1)	TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 20, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][3] == 1) TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 20, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
                        else if (MenuStatus[26][4] == 1) TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 20, 455, 1, Buffer_UI2Plane);	// Draw Menu Data Text
					}
					else
					{
                        if (MenuStatus[26][2] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 20, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_mul.Read_Text(), ispacer + 20, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
                        else if (MenuStatus[26][3] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 20, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_sub.Read_Text(), ispacer + 20, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
                        else if (MenuStatus[26][4] == 1)	
                        {
                            TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 20, 455, 0, Buffer_UI2Plane);	// Draw Menu Data Text
                            TEXTOUTxvbig(Math_Offset_add.Read_Text(), ispacer + 20, 455, 1, UI_Plane5);	// Draw Menu Data Text												
                        }
					}
					break;
				}
            }
            break;
        }        	
	}
	
	// Text Correction for Pulse Width Item 2
	if ((MenuNr == 15) && (ItemNr == 2))
	{
		if (MenuStatus[MenuNr][ItemNr] == 2) textcorr = -9;
		else if (MenuStatus[MenuNr][ItemNr] == 3) textcorr = 8;
	}	

	if (MenuStatus[MenuNr][ItemNr] < 240)
	{
		if (active)
		{
			TEXTOUTxvbig(MenuData[MenuStatus[MenuNr][ItemNr]], ispacer + MenuDataDef[MenuStatus[MenuNr][ItemNr]] + textcorr, 455, 1, Buffer_UI2Plane);				// Draw Menu Data Text
		}
		else
		{
			TEXTOUTxvbig(MenuData[MenuStatus[MenuNr][ItemNr]], ispacer + MenuDataDef[MenuStatus[MenuNr][ItemNr]] + textcorr, 455, 0, Buffer_UI2Plane);				// Draw Menu Data Text
			TEXTOUTxvbig(MenuData[MenuStatus[MenuNr][ItemNr]], ispacer + MenuDataDef[MenuStatus[MenuNr][ItemNr]] + textcorr, 455, 1, UI_Plane5);				// Draw Menu Data Text			
		}		
	}
	else if ((MenuStatus[MenuNr][ItemNr] > 239) && (MenuStatus[MenuNr][ItemNr] < 242)) DrawMenuCheckBox(ispacer + 46, 457, MenuStatus[MenuNr][ItemNr] - 240, active);  	// Draw a Checkbox
	else if ((MenuStatus[MenuNr][ItemNr] > 241) && (MenuStatus[MenuNr][ItemNr] < 244)) DrawMenuArrow(ispacer + 31, MenuStatus[MenuNr][ItemNr] - 242, active);			// Draw a Arrow
	else if ((MenuStatus[MenuNr][ItemNr] > 243) && (MenuStatus[MenuNr][ItemNr] < 246)) DrawMenuArrow(ispacer + 31, MenuStatus[MenuNr][ItemNr] - 244, 0);			    // Draw a Arrow Grayed	
	else if (MenuStatus[MenuNr][ItemNr] == 247) DrawSubMenuArrow(ispacer + 31, active);																					// Draw a SubArrow	
#ifdef _Debug_	
	printf("MNr %d  INr %d : %d\n", MenuNr, ItemNr, MenuStatus[MenuNr][ItemNr]);
#endif	
	MenuItemChanged[ItemNr] = 0;
//	UpdateMenuTextPlane = true;
}
//##########################################################################################################################################################

void Display::DrawMenuItemButton(int ItemNr, unsigned char active, unsigned char pushed)
{
	int ispacer = 0;
	
	//if ((Active_Menu == 15) && (ItemNr == 1)) return; // for pulse width
	
	// Get Menuitem Pos
	switch(ItemNr)
	{
		case 0:
		{
			ispacer = 8;
			break;
		}
		case 1:
		{
			ispacer = 113;
			break;
		}
		case 2:
		{
			ispacer = 218;
			break;
		}
		case 3:
		{
			ispacer = 323;
			break;
		}
		case 4:
		{
			ispacer = 428;
			break;
		}
		case 5:
		{
			ispacer = 533;
			break;
		}
	}									
			
	// Draw Button Frame
	DRAWROUNDBUTTON(ispacer - 3, 432, 106, 46, pushed, btnDraw);	
}
//##########################################################################################################################################################
// BF drawing menu buttons on the screen
void Display::UpdateMenu(void)
{
    	int cnt;
	char BufferText[20];
	//char MenuAktMem;

	char Btns_to_remove[6] = {0, 0, 0, 0, 0, 0};           //remove the button + text
	char Btns_to_remove_text[6] = {0, 0, 0, 0, 0, 0};      //remove the text
	char Btns_to_draw[6] = {0, 0, 0, 0, 0, 0};             //draw button
	char Btns_to_redraw[6] = {0, 0, 0, 0, 0, 0};           //draw text


#ifdef _Debug_
    printf("UpdateMenu\n");
#endif
	//printf("\rWe are here and NewMenu is %d Active_Menu is %d MenuAktive is %d\r\n", New_Menu, Active_Menu, MenuAktive);

	if (Splash_removed)
	{
		for (cnt = 0; cnt < 6; cnt++)
		{
			if (MenuItemDef[New_Menu][cnt] != 0)
			{ Btns_to_draw[cnt] = 1; Btns_to_redraw[cnt] = 1; MenuItemPushed[cnt] = 0; MenuItemPushed_old[cnt] = 0;}
		}
		Splash_removed = false;
	}
	// Check if Menu changed
	else if (New_Menu != Active_Menu)
	{
		MenuAktive = 1;
	
		//BF del if (((New_Menu == 17) && (USB_Connected == false))) MenuAktive = 0; // Grayed menus

		for (cnt = 0; cnt < 6; cnt++)
		{
			if (MenuItemDef[Active_Menu][cnt] != 0)
			{
				if (MenuItemDef[New_Menu][cnt] == 0)
				{	Btns_to_remove[cnt] = 1; }
				else
				{
					Btns_to_draw[cnt] = 1;
					Btns_to_remove_text[cnt] = 1;
					Btns_to_redraw[cnt] = 1;
				}
			}
			else
			{
				if (MenuItemDef[New_Menu][cnt] != 0)
				{ Btns_to_draw[cnt] = 1; Btns_to_redraw[cnt] = 1; }
			}
		}		
	}
	else	//BF New Menu = Active Menu
	{
		//BF del if (((New_Menu ==  MENU_QUICKPRINT) && (USB_Connected == false))) MenuAktive = 0; // Grayed menus

		for (cnt = 0; cnt < 6; cnt++)
		{
			//if (((MenuAktive != MenuAktive_old) || (MenuItemChanged[cnt] == 1)) && (MenuItemDef[New_Menu][cnt] != 0))
			if (MenuItemDef[Active_Menu][cnt] != 0)
			{
				//BF if ((MenuItemPushed[cnt]) || (MenuItemPushed_old[cnt]))
				//if (MenuItemPushed[cnt])
				//{
				        //Btns_to_remove[cnt] = 1;
					Btns_to_redraw[cnt] = 1;
					Btns_to_remove_text[cnt] = 1;
					Btns_to_draw[cnt]   = 1;
					//MenuItemPushed_old[cnt] = 0;
					//printf("\rButton pushed %d\r\n", cnt);
			/*	}
				else
				{
					
					Btns_to_redraw[cnt] = 1;
					Btns_to_draw[cnt]   = 1;
					Btns_to_remove_text[cnt] = 1;
					//printf("\rButton redraw %d\r\n", cnt);
				}
			*/	//Btns_to_draw[cnt]   = 1;
				//Btns_to_redraw[cnt] = 1;
			}
		}
	}

	for (cnt = 0; cnt < 6; cnt++)
    	{
        	if (Btns_to_remove[cnt] == 1)      Display::ClearMenuItemAsm(cnt, 34560, 44);
        	if (Btns_to_draw[cnt] == 1)        Display::DrawMenuItemButton(cnt, 1, MenuItemPushed[cnt]);
          	if (Btns_to_remove_text[cnt] == 1) Display::ClearMenuItemTextAsm(cnt, 35040, 32);
		if (Btns_to_redraw[cnt] == 1)      Display::DrawMenuItem(New_Menu, cnt, MenuAktive, 0);
 	} 
	
	if (Cursor_Enabled) DRAWCURSORDATA(0);
	//if (QM_Enabled) CALCQMDATA();
	
	MenuAktive_old      = MenuAktive;
	Active_Menu         = New_Menu;
	Menu_Changed        = 0;
	UpdateMenuTextPlane = true;
	VSync_Needed        = 1;	
}
