#include "hardware_t.h"
#include "tc_vars.h"
#include "flash_t.h"
#include "display_t.h"
//#include "math.h"

// Class Display
//##########################################################################################################################################################
// BF this function draws vertical lines
// BF Attention!!! y and y2 must not be equal because in this case system crashes. The first point on vertical
// position y is not drawn -> this must be done via PIXELP()
void Display::Connect_Pixels(int x, short y, short y2, int dir, unsigned long *planeaddress, unsigned char on)
{
    if (on)
    {
        if (dir == 1)
        {
            asm("
             MOV	%r1, %i0                       ; Load X to %r1

             MOV	%r2, %i0                       ; Load X to %r2
             LSRI   %r2, 5                         ; Shift %r2 right 5 times to calculate wordoffset (x / 32)      Bitfilter
             LSLI   %r2, 2                         ; Shift %r2 left 2 times to calculate wordoffset (x / 32) * 4

             MOV	%r3, %i1                   ; Load Y to %r3

             ;ADDI   %r3, GRID_YOFFS                ; Add Correction Value -> BF del no offset here!!

             MOV    %r4, %r3                       ; Save %r3 to %r4

             LSLI   %r3, 2                         ; Shift %r3 2 times to get Y * 4
             ADD    %r3, %r4                       ; Add %r4 to %r3 to get Y * 5
             LSLI   %r3, 4                         ; Shift %r3 4 times to get Y * 80

             ADD    %r3, %r2                       ; Add wordoffset to y offset address and store in %r3

             LSLI   %r2, 3                         ; Shift %r0 to get wordoffset without bit value

             SUB    %r1, %r2                       ; Subtract %r2 from %r1 to get Bitaddress stored in %r1

             MOV	%r4, %i4                       ; Load BufferAddress to %r4

             ADD    %r4, %r3                       ; Calculate Memoryaddress

             PFX	%hi(0x80000000)                ; Load bitmask
             MOVI	%r5,%lo(0x80000000)
             PFX	%xhi(0x80000000)
             MOVHI	%r5,%xlo(0x80000000)

             LSR    %r5, %r1                       ; Calculate Bit to set


             MOV	%r6, %i2                   ; Load End Y to %r6

             SUB    %r6, %i1                       ; Get the Difference

             cp_loop1:

             LD     %r0, [%r4]                     ; Load Value from Memory
             OR     %r0, %r5                       ; Set Calculated Bit
             ST     [%r4], %r0                     ; Store Back to Memory

             PFX    %hi(80)
             ADDI   %r4, %lo(80)                   ; Add 80 to Address

             SUBI   %r6, 1                         ; Decrement Y Counter
             SKPS   cc_z                           ; Test of Zero
             BR     cp_loop1                       ; Jump to Loop
             NOP

            ");
        }
    	else
        {
            asm("
             MOV	%r1, %i0                       ; Load X to %r1

             MOV	%r2, %i0                       ; Load X to %r2
             LSRI   %r2, 5                         ; Shift %r2 right 5 times to calculate wordoffset (x / 32)      Bitfilter
             LSLI   %r2, 2                         ; Shift %r2 left 2 times to calculate wordoffset (x / 32) * 4

             MOV	%r3, %i2                       ; Load Y to %r3

             ;ADDI   %r3, GRID_YOFFS                ; Add Correction Value BF del

             MOV    %r4, %r3                       ; Save %r3 to %r4

             LSLI   %r3, 2                         ; Shift %r3 2 times to get Y * 4
             ADD    %r3, %r4                       ; Add %r4 to %r3 to get Y * 5
             LSLI   %r3, 4                         ; Shift %r3 4 times to get Y * 80

             ADD    %r3, %r2                       ; Add wordoffset to y offset address and store in %r3

             LSLI   %r2, 3                         ; Shift %r0 to get wordoffset without bit value

             SUB    %r1, %r2                       ; Subtract %r2 from %r1 to get Bitaddress stored in %r1

             MOV	%r4, %i4                       ; Load BufferAddress to %r4

             ADD    %r4, %r3                       ; Calculate Memoryaddress

             PFX	%hi(0x80000000)                ; Load bitmask
             MOVI	%r5,%lo(0x80000000)
             PFX	%xhi(0x80000000)
             MOVHI	%r5,%xlo(0x80000000)

             LSR    %r5, %r1                       ; Calculate Bit to set


             MOV	%r6, %i1                       ; Load End Y to %r6

             SUB    %r6, %i2                       ; Get the Difference

             cp_loop2:

             LD     %r0, [%r4]                     ; Load Value from Memory
             OR     %r0, %r5                       ; Set Calculated Bit
             ST     [%r4], %r0                     ; Store Back to Memory

             PFX    %hi(80)
             ADDI   %r4, %lo(80)                   ; Add 80 to Address

             SUBI   %r6, 1                         ; Decrement Y Counter
             SKPS   cc_z                           ; Test of Zero
             BR     cp_loop2                       ; Jump to Loop
             NOP

            ");
	   }		
    }
    else
    {
        if (dir == 1)
        {
            asm("
             MOV	%r1, %i0                       ; Load X to %r1

             MOV	%r2, %i0                       ; Load X to %r2
             LSRI   %r2, 5                         ; Shift %r2 right 5 times to calculate wordoffset (x / 32)      Bitfilter
             LSLI   %r2, 2                         ; Shift %r2 left 2 times to calculate wordoffset (x / 32) * 4

             MOV	%r3, %i1                       ; Load Y to %r3

             ;ADDI   %r3, GRID_YOFFS                ; Add Correction Value BF del

             MOV    %r4, %r3                       ; Save %r3 to %r4

             LSLI   %r3, 2                         ; Shift %r3 2 times to get Y * 4
             ADD    %r3, %r4                       ; Add %r4 to %r3 to get Y * 5
             LSLI   %r3, 4                         ; Shift %r3 4 times to get Y * 80

             ADD    %r3, %r2                       ; Add wordoffset to y offset address and store in %r3

             LSLI   %r2, 3                         ; Shift %r0 to get wordoffset without bit value

             SUB    %r1, %r2                       ; Subtract %r2 from %r1 to get Bitaddress stored in %r1

             MOV	%r4, %i4                       ; Load BufferAddress to %r4

             ADD    %r4, %r3                       ; Calculate Memoryaddress

             PFX	%hi(0x00000000)                ; Load bitmask
             MOVI	%r5,%lo(0x00000000)
             PFX	%xhi(0x00000000)
             MOVHI	%r5,%xlo(0x00000000)

             ;LSR    %r5, %r1                       ; Calculate Bit to set


             MOV	%r6, %i2                       ; Load End Y to %r6

             SUB    %r6, %i1                       ; Get the Difference

             cp_loop01:

             ;LD     %r0, [%r4]                     ; Load Value from Memory
             MOV    %r0, %r5                       ; Set Calculated Bit
             ST     [%r4], %r0                     ; Store Back to Memory

             PFX    %hi(80)
             ADDI   %r4, %lo(80)                   ; Add 80 to Address

             SUBI   %r6, 1                         ; Decrement Y Counter
             SKPS   cc_z                           ; Test of Zero
             BR     cp_loop01                      ; Jump to Loop
             NOP

            ");
        }
    	else
        {
            asm("
             MOV	%r1, %i0                       ; Load X to %r1

             MOV	%r2, %i0                       ; Load X to %r2
             LSRI   %r2, 5                         ; Shift %r2 right 5 times to calculate wordoffset (x / 32)      Bitfilter
             LSLI   %r2, 2                         ; Shift %r2 left 2 times to calculate wordoffset (x / 32) * 4

             MOV	%r3, %i2                       ; Load Y to %r3

             ;ADDI   %r3, GRID_YOFFS                ; Add Correction Value BF del

             MOV    %r4, %r3                       ; Save %r3 to %r4

             LSLI   %r3, 2                         ; Shift %r3 2 times to get Y * 4
             ADD    %r3, %r4                       ; Add %r4 to %r3 to get Y * 5
             LSLI   %r3, 4                         ; Shift %r3 4 times to get Y * 80

             ADD    %r3, %r2                       ; Add wordoffset to y offset address and store in %r3

             LSLI   %r2, 3                         ; Shift %r0 to get wordoffset without bit value

             SUB    %r1, %r2                       ; Subtract %r2 from %r1 to get Bitaddress stored in %r1

             MOV	%r4, %i4                       ; Load BufferAddress to %r4

             ADD    %r4, %r3                       ; Calculate Memoryaddress

             PFX	%hi(0x00000000)                ; Load bitmask
             MOVI	%r5,%lo(0x00000000)
             PFX	%xhi(0x00000000)
             MOVHI	%r5,%xlo(0x00000000)

             ;LSR    %r5, %r1                       ; Calculate Bit to set


             MOV	%r6, %i1                       ; Load End Y to %r6

             SUB    %r6, %i2                       ; Get the Difference

             cp_loop02:

             ;LD     %r0, [%r4]                     ; Load Value from Memory
             MOV    %r0, %r5                       ; Set Calculated Bit
             ST     [%r4], %r0                     ; Store Back to Memory

             PFX    %hi(80)
             ADDI   %r4, %lo(80)                   ; Add 80 to Address

             SUBI   %r6, 1                         ; Decrement Y Counter
             SKPS   cc_z                           ; Test of Zero
             BR     cp_loop02                      ; Jump to Loop
             NOP

            ");
        }		
    }
}
//##########################################################################################################################################################
//BF completely redesigned
void Display::DrawSignals(unsigned char on)	// Draw all active signals
{
	unsigned char *lp_Signal     = NULL;
	unsigned char *lp_SigIntpol  = NULL;
	unsigned char *lp_SigIntpDel = NULL;
	unsigned char lvector = 0;

	if(UI_request) return;   //if interrupt from user interface occured don't draw signals

	//set drawing planes
	DrawPlane = 0x00;
	if (Channel_1_Active == 1) DrawPlane |= 0x01;	
	if (Channel_2_Active == 1) DrawPlane |= 0x02;	
	if (Channel_3_Active == 1) DrawPlane |= 0x04;	
	if (Channel_4_Active == 1) DrawPlane |= 0x08;
	if (Channel_Math_Active == 1) DrawPlane |= 0x10;

	// if a menu popup is visible, do not write signals in planes
	if ( Menu_Popup_visible )
	{	
		ClearPlane = DrawPlane | RemovePlane;
		DrawPlane = 0;	
		return;
	}

	//set vector switch
	if (MenuStatus[MENU_DISPLAY][3] == 240)	//Display menu -> Vectors inactive
	{ lvector = 0; }
	else
	{ lvector = 1; }

	//BF refresh control for USTB
	if (USTB_Mode != USTB_OFF)
	{
		if (USTB_Refresh >= 600)
		USTB_Refresh = 0;
		else return;
	}

	//---------------------------------------------------------------------------------------------------------------------------------------	
	//                                     draw x/y signal
	//---------------------------------------------------------------------------------------------------------------------------------------	
	if (XY_Mode)
	{ 
		DrawPlane = 0x00;
		if (Channel_1_Active && Channel_2_Active && !UI_request)
		{
			if (Selected_Timebase < 4 || USTB_Mode != USTB_OFF) //Timebase 20nS & 10nS & 5nS & 2nS
			{ DRAWSIGNAL_XY( 1, 2, draw_start, &SIGNAL1_Intpolate[0], &SIGNAL2_Intpolate[0], on, lvector); }
			else
			{ DRAWSIGNAL_XY( 1, 2, draw_start, &SIGNAL1[0], &SIGNAL2[0], on, lvector); }
			
			DrawPlane |= 0x01;
		}
		
		if (Channel_3_Active && Channel_4_Active && !UI_request)
		{
			if (Selected_Timebase < 4 || USTB_Mode != USTB_OFF)  //Timebase 20nS & 10nS & 5nS & 2nS
			{ DRAWSIGNAL_XY( 3, 4, draw_start, &SIGNAL3_Intpolate[0], &SIGNAL4_Intpolate[0], on, lvector); }
			else
			{ DRAWSIGNAL_XY( 3, 4, draw_start, &SIGNAL3[0], &SIGNAL4[0], on, lvector); }

			DrawPlane |= 0x04;
		}

		ClearPlane = DrawPlane | RemovePlane;
        	DrawPlane = 0;

		return;
	}

	//---------------------------------------------------------------------------------------------------------------------------------------	
	//                                  draw f/y spectrum (FFT)
	//---------------------------------------------------------------------------------------------------------------------------------------	
	if (FFT_Mode != FFT_OFF)
	{ 
		if(FFT_NewData)
		{ 	
			DRAWSPECTRUM_FY(on); FFT_NewData = 0; 
			//DrawPlane =  0x10;
			ClearPlane = DrawPlane | RemovePlane;
        		DrawPlane = 0x00;
		}
		return;
	}

	//---------------------------------------------------------------------------------------------------------------------------------------	
	//                            draw time signal t/y of active channels one after another
	//---------------------------------------------------------------------------------------------------------------------------------------	

	for (unsigned char lv_channel = 1 ; lv_channel <= 5 ; lv_channel ++ )
	{
		if(UI_request) //if interrupt occured don't draw next signals
        	{ 
			ClearPlane = DrawPlane | RemovePlane;
        		DrawPlane  = 0;	
			//UI_request = 0;
			return;
		}

		switch (lv_channel)
		{
			case 1: if(Channel_1_Active)
				{ lp_Signal = &SIGNAL1[0]; lp_SigIntpol = &SIGNAL1_Intpolate[0]; lp_SigIntpDel = &SIGNAL1_Intpolate_delayed[0]; }
				else continue; break;
			case 2: if(Channel_2_Active)
				{ lp_Signal = &SIGNAL2[0]; lp_SigIntpol = &SIGNAL2_Intpolate[0]; lp_SigIntpDel = &SIGNAL2_Intpolate_delayed[0]; }
				else continue; break;
			case 3: if(Channel_3_Active)
				{ lp_Signal = &SIGNAL3[0]; lp_SigIntpol = &SIGNAL3_Intpolate[0]; lp_SigIntpDel = &SIGNAL3_Intpolate_delayed[0]; }
				else continue; break;
			case 4: if(Channel_4_Active)
				{ lp_Signal = &SIGNAL4[0]; lp_SigIntpol = &SIGNAL4_Intpolate[0]; lp_SigIntpDel = &SIGNAL4_Intpolate_delayed[0]; }
				else continue; break;
			case 5: if(Channel_Math_Active)
				{ lp_Signal = &SIGNALM[0]; lp_SigIntpol = &SIGNALM_Intpolate[0]; lp_SigIntpDel = &SIGNALM_Intpolate_delayed[0]; }
				else continue; break;
		}

		//-------------------------------------------------
		//draw T-Y time signal
		//-------------------------------------------------
		if (Selected_Timebase < 4) //Timebase 20nS & 10nS & 5nS -> interpolated timebases
		{
			//Draw main Signal (in delayed mode into top window (window = 1)
			DRAWSIGNAL_TY(lv_channel, 1, draw_factor, draw_start, lp_SigIntpol, on, lvector);

			if (MenuStatus[10][1] == 1)	//Delayed mode -> draw into bottom window (window = 2)
			{ DRAWSIGNAL_TY(lv_channel, 2, draw_dm_ixfactor, draw_dm_ixstart, lp_SigIntpDel, on, lvector); }
		}
		else if (Selected_Timebase >= 4 && USTB_Mode == USTB_OFF)	//Timebase 50nS - 200mS
		{
			//Draw main Signal (in delayed mode into top window (window = 1)
			//printf("\ndrawing in main mode with Timebase %d\n", Selected_Timebase);	

			DRAWSIGNAL_TY(lv_channel, 1, draw_factor, draw_start, lp_Signal, on, lvector);
			
			if (MenuStatus[10][1] == 1)	//Delayed mode -> draw into bottom window (window = 2)
			{
				if (dmode_Selected_Timebase < 4)	//delayed timebase 20ns & 10ns & 5 ns
				{ DRAWSIGNAL_TY(lv_channel, 2, draw_dm_ixfactor, draw_dm_ixstart, lp_SigIntpDel, on, lvector); }
				else					//delayed timebase >= 50ns
				{ DRAWSIGNAL_TY(lv_channel, 2, draw_dm_ixfactor, draw_dm_ixstart, lp_Signal, on, lvector); }
			}
		}
		else if (USTB_Mode != USTB_OFF)	//USTB mode timebase 1S - 200S
		{
			DRAWSIGNAL_TY(lv_channel, 1, 1, 0, lp_SigIntpol, on, lvector);
		}

	} //Channel loop end


        ClearPlane = DrawPlane | RemovePlane;
        DrawPlane = 0x00;	

	if ((QM_Enabled) && (QM_Type[0] > 0)) Display::CALCQMDATA();


}
//##########################################################################################################################################################
// BF Timebase 50ns is the fastest real timebase. For timebase 20nS, 10nS, 5nS and 2nS the additonal samples must be interpolated 
// BF replaced complete interpolation with a simplified routine
// BF new linear interpolation
void Display::Interpolate(int timebase, int start, unsigned char *SignalData, unsigned char *InterpolateResult)
{
    int ix,iy,incr;
	
	if (UI_request) return;	

	//printf("\r\ninterpolation start %d\r\n", start);	

	if(!test_sw2)
	{
		//printf("Linear interpolation on TB %d\r\n", timebase);

		if (timebase == 0)		// 2ns 
		{
			for(ix=0,iy=start;ix < (GRID_WIDTH + 25);ix+=25,iy++)
			LinearInterpolation(ix, (int)SignalData[iy], ix + 25, (int)SignalData[iy+1], InterpolateResult);
		}
		else if (timebase == 1)		// 5ns 
		{
			for(ix=0,iy=start;ix < (GRID_WIDTH + 10);ix+=10,iy++)
			LinearInterpolation(ix, (int)SignalData[iy], ix + 10, (int)SignalData[iy+1], InterpolateResult);
		}
		else if (timebase == 2)		// 10ns 
		{
			for(ix=0,iy=start;ix < (GRID_WIDTH + 5);ix+=5,iy++)
			LinearInterpolation(ix, (int)SignalData[iy], ix + 5, (int)SignalData[iy+1], InterpolateResult);
		}
		else if (timebase == 3)		// 20ns 
		{
			for(ix=0,iy=start,incr=2;ix < (GRID_WIDTH + 25);ix+=incr,iy++)
			{
				//toggle increment
				if(incr == 2){incr = 3;}
				else{incr = 2;}

				LinearInterpolation(ix, (int)SignalData[iy], ix + incr, (int)SignalData[iy+1], InterpolateResult);
			}

		}
		else
		{ printf("\r\nUnsupported timebase %d\r\n", timebase); }
	
	}
	else
	{
		int delta,rx;
		
		//printf("Simple interpolation on TB %d\r\n", timebase);

		if (timebase == 0)		// 2ns 
		{
			//for(ix=start,rx=0;rx < ((GRID_WIDTH * 2)-25);ix++,rx+=25)
			for(ix=start,rx=0;rx < (GRID_WIDTH + 25);ix++,rx+=25)
			{
				//copy original value
				InterpolateResult[rx] = SignalData[ix];
	
				//calc the difference between actual and next value
				delta = (SignalData[ix+1] - SignalData[ix]);
				
				//interpolate the next 24 values
				for (int j=1;j <= 24;j++)
				{ InterpolateResult[rx+j] = SignalData[ix] + (delta / ( 25 -j ) ); }
			}
		}
		else if (timebase == 1)		// 5ns 
		{
			//for(ix=start,rx=0;rx < ((GRID_WIDTH * 2)-10);ix++,rx+=10)
			for(ix=start,rx=0;rx < (GRID_WIDTH + 10);ix++,rx+=10)
			{
				//copy original value
				InterpolateResult[rx] = SignalData[ix];
	
				//calc the difference between actual and next value
				delta = (SignalData[ix+1] - SignalData[ix]);
				
				//interpolate the next 9 values
				for (int j=1;j <= 9;j++)
				{ InterpolateResult[rx+j] = SignalData[ix] + (delta / ( 10 -j ) ); }
			}
		}
		else if (timebase == 2)		// 10ns 
		{
			//for(ix=start,rx=0;rx < ((GRID_WIDTH * 2)-5);ix++,rx+=5)
			for(ix=start,rx=0;rx < (GRID_WIDTH + 5);ix++,rx+=5)
			{
				//copy original value
				InterpolateResult[rx] = SignalData[ix];
	
				//calc the difference between actual and next value
				delta = (SignalData[ix+1] - SignalData[ix]);
				
				//interpolate the next 4 values
				for (int j=1;j <= 4;j++)
				{ InterpolateResult[rx+j] = SignalData[ix] + (delta / ( 5 -j ) ); }
			}
	
		}
		else if (timebase == 3)		// 20ns 
		{
			//for(ix=start,rx=0,incr=1;rx < ((GRID_WIDTH * 2)-3);ix++,rx+=(incr+1))
			for(ix=start,rx=0,incr=1;rx < (GRID_WIDTH + 3);ix++,rx+=(incr+1))
			{
				//toggle increment
				if(incr == 1){incr = 2;}
				else{incr = 1;}
	
				//copy original value
				InterpolateResult[rx] = SignalData[ix];
	
				//calc the difference between actual and next value
				delta = (SignalData[ix+1] - SignalData[ix]);
			
				//interpolate the next 1 - 2  values
				for (int j=1;j <= incr;j++)
				{ InterpolateResult[rx+j] = SignalData[ix] + (delta / ( incr + 1 -j ) ); }
			}
		}
		else
		{ printf("\r\nUnsupported timebase %d\r\n", timebase); }

	}
}
//##########################################################################################################################################################
// BF linear interpolation with Bresenham algorithm
void Display::LinearInterpolation(int x1, int y1, int x2, int y2, unsigned char *interpolation)
{
	
	//--------------------------------------------
	//special case horizontal line
	//--------------------------------------------
	if(y1 == y2)
	{
		if(x1 < x2)
		for(; x1 != x2; x1++)	{ interpolation[x1] = (char)y1; }
		else
		for(; x2 != x1; x2++)	{ interpolation[x2] = (char)y1; }
		return;
	}	

	//--------------------------------------------
	//special case vertical line
	//--------------------------------------------
	else if(x1 == x2)
	{
		if(y1 < y2)
		for(; y1 != y2; y1++)	{ interpolation[x1] = (char)y1; }
		else
		for(; y2 != y1; y2++)	{ interpolation[x1] = (char)y2; }
		return;
	}	

	//-------------------------------------------------------------
	// Bresenham algorithm for drawing diagonal lines
	//-------------------------------------------------------------
	int dy = y2 - y1;
        int dx = x2 - x1;
        int stepx, stepy;

	//check if delta is positive or negative
	if (dy < 0) { dy = -dy;  stepy = -1; } else { stepy = 1; }
        if (dx < 0) { dx = -dx;  stepx = -1; } else { stepx = 1; }

	//special case exact 45 degrees delta x / delta y = 1
	if (dx == dy)
	{
		//horizontal and vertical component increment constant with 1 
		if(x1 < x2) 
		{
			if(y1 < y2)
			{ 
				for(; x1 != x2; x1++, y1++)
				{ interpolation[x1] = (char)y1; }
				return;
			}
			else if(y1 > y2)
			{
				for(; x1 != x2; x1++, y1--)
				{ interpolation[x1] = (char)y1; }
				return;
			}
			
		}
		else if(x1 > x2)
		{
			if(y1 < y2) 
			{
				for(; x1 != x2; x1--, y1++)
				{ interpolation[x1] = (char)y1; }
				return;
			}
			else if(y1 > y2)
			{
				for(; x1 != x2; x1--, y1--)
				{ interpolation[x1] = (char)y1; }
				return;
			}
		}
	}

	
        dy <<= 1;                              		// dy is now 2*dy
        dx <<= 1;                              		// dx is now 2*dx
	
	//set starting point
	interpolation[x1] = (char)y1;
	
	//---------------------------------------------
	//between horizontal and 45 degrees
	//---------------------------------------------
	if (dx > dy)
	{
		int fraction = dy - (dx >> 1);   	// same as 2*dy - dx
		while (x1 != x2) {
			if (fraction >= 0) {
			y1 += stepy;
			fraction -= dx;              	// same as fraction -= 2*dx
			}
			x1 += stepx;
			fraction += dy;          	// same as fraction -= 2*dy
			interpolation[x1] = (char)y1;
		}
        	return;
	}

	//---------------------------------------------
	//between vertical and 45 degrees
	//---------------------------------------------
	if (dx < dy)
	{
		int fraction = dx - (dy >> 1);
		while (y1 != y2) {
			if (fraction >= 0) {
			x1 += stepx;
			fraction -= dy;
			}
			y1 += stepy;
			fraction += dx;
			interpolation[x1] = (char)y1;
		}
		return;
        }

}
//##########################################################################################################################################################
// BF Signal processing
void Display::ProcessSignalData(void)
{
	unsigned char *lp_sig1 = NULL;	//pointer to signal 1
	unsigned char *lp_sig2 = NULL;	//pointer to signal 2
	unsigned char *lp_sigM = NULL;	//pointer to math signal 

	int lix, lfactor, lcalcstop;

	if (UI_request && (USTB_Mode == USTB_OFF)) return;	

	// generate test signals
	//if(test_signal)
	//{ TestSignalGenerate(); }

//---------------------------------------------------------------------------------------
//		Calculate Window size for drawing
//---------------------------------------------------------------------------------------
	if (Selected_Timebase < 4) //BF 20ns + 10ns + 5ns + 2ns main mode - interpolated signal
	{
		draw_start = 0; //(short) MemWinStart + Trigger_Offset_Calc;
		//if (draw_start < 0) draw_start = 0;

		//BF not needed    draw_stop  = draw_start + GRID_WIDTH;
		draw_factor = 1;

		//set pointers to signals
		lp_sig1 = &SIGNAL1_Intpolate[0];
		lp_sig2 = &SIGNAL2_Intpolate[0];
		lp_sigM = &SIGNALM_Intpolate[0];
	}
	else if (FFT_Mode != FFT_OFF || USTB_Mode != USTB_OFF)
	{
		draw_start = 0;
		draw_factor = 1;
	}
	else //BF >= 50ns main mode - true signal
	{
		//BF draw_start = (short) MemWinStart + 40;
		draw_start = (short) MemWinStart + Trigger_Offset_Calc;

		if (draw_start < 0) draw_start = 0;
		
		//BF not needed    draw_stop = draw_start + SIG_Size[ZIT_short] - 1;
		draw_factor = (short) ZFT_float;
		
		//set pointers to signals
		lp_sig1 = &SIGNAL1[0];
		lp_sig2 = &SIGNAL2[0];
		lp_sigM = &SIGNALM[0];
	}


	if (MenuStatus[10][1] == 1)	//Delayed
	{
		if (dmode_Selected_Timebase < 4) //20ns + 10ns delayed mode  - interpolated signal
		{
			draw_dm_ixstart = 0;		//(short) MemWinStart + (dmode_Window_Offset_Pos * ZFT_float) + Trigger_Offset_Calc;
	
			draw_dm_ixfactor = (short) ZFT_float_dmode;	
	
			draw_dm_ixoffset = (short) ((float) dmode_Window_Offset_Pos * ZFT_float) + MemWinStart;
		}
		else	// >= 50ns delayed mode - true signal
		{
			draw_dm_ixstart = MemWinStart + (short)((float)(((GRID_WIDTH / 2) - (short) (Cursor_Delayed_Size / 2)) + dmode_Window_Offset_Pos) * ZFT_float);

			draw_dm_ixfactor = (short) ZFT_float_dmode;	
		}
		lfactor = 1;	//calculate all math values
	}	
	else //Main Mode
	{ lfactor = draw_factor; } 

	//width of calculating for math functions
	lcalcstop = draw_start + ((GRID_WIDTH + 30) * draw_factor);
	if (lcalcstop > 16383){lcalcstop = 16383;}

        //--------------------------------------------------------------------------------------
	//        		 ultra slow timebase mode (roll mode / shift mode)
	//--------------------------------------------------------------------------------------
	if (USTB_NewData)
	{
		unsigned char lchannelcnt = 0;
		//get number of active channels
		if (Channel_1_Active) lchannelcnt ++;	
		if (Channel_2_Active) lchannelcnt ++;	
		if (Channel_3_Active) lchannelcnt ++;	
		if (Channel_4_Active) lchannelcnt ++;	

		USTB_NewData = 0;

		//refresh rate 
		switch(Selected_Timebase)
		{
			case 24: USTB_Refresh += (30 / lchannelcnt);	break;	//1S/Div
			case 25: USTB_Refresh += (60 / lchannelcnt);	break;	//2S/Div
			case 26: USTB_Refresh += (600 / lchannelcnt);	break;	//5S/Div
			case 27: USTB_Refresh += 600;	break;	//10S/Div
			case 28: USTB_Refresh += 600;	break;	//20S/Div
			case 29: USTB_Refresh += 600;	break;	//50S/Div
			case 30: USTB_Refresh += 600;	break;	//100S/Div
			case 31: USTB_Refresh += 600;	break;	//200S/Div
		}

		//Check for time pointer overflow
		if(USTB_Roll_idx > GRID_WIDTH)
		USTB_Roll_idx = 0;


		if (USTB_Mode == USTB_ROLL)	//roll mode
		{
			if (Channel_1_Active)	
			{ USTB_roll_signal(USTB_Roll_idx, &SIGNAL1[0], &SIGNAL1_USTB[0]); }

			if (Channel_2_Active)
			{ USTB_roll_signal(USTB_Roll_idx, &SIGNAL2[0], &SIGNAL2_USTB[0]); }

			if (Channel_3_Active)
			{ USTB_roll_signal(USTB_Roll_idx, &SIGNAL3[0], &SIGNAL3_USTB[0]); }

			if (Channel_4_Active)
			{ USTB_roll_signal(USTB_Roll_idx, &SIGNAL4[0], &SIGNAL4_USTB[0]); }

			//increment time pointer
			USTB_Roll_idx ++;
		}
		else if (USTB_Mode == USTB_SHIFT)	//shift mode
		{
			if (Channel_1_Active)	
			{ USTB_shift_signal(&SIGNAL1[0], &SIGNAL1_USTB[0]); }

			if (Channel_2_Active)
			{ USTB_shift_signal(&SIGNAL2[0], &SIGNAL2_USTB[0]); }

			if (Channel_3_Active)
			{ USTB_shift_signal(&SIGNAL3[0], &SIGNAL3_USTB[0]); }

			if (Channel_4_Active)
			{ USTB_shift_signal(&SIGNAL4[0], &SIGNAL4_USTB[0]); }
		}
	
	}

        //--------------------------------------------------------------------------------------
	//        	 Interpolation (time stretch) for timebase 20ns, 10ns (5ns)
	//--------------------------------------------------------------------------------------
	if(USTB_Mode == USTB_OFF && FFT_Mode == FFT_OFF)	
	{
		if (Channel_1_Active)
		{	
			if (Selected_Timebase < 4)
			{ Interpolate(Selected_Timebase, MemWinStart + Trigger_Offset_Calc, &SIGNAL1[0], &SIGNAL1_Intpolate[0]); }
			
			if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4)) //delayed mode
			{ Interpolate(dmode_Selected_Timebase, draw_dm_ixoffset, &SIGNAL1[0], &SIGNAL1_Intpolate_delayed[0]); }
		}
		
		if (Channel_2_Active)
		{	
			if (Selected_Timebase < 4)
			{ Interpolate(Selected_Timebase, MemWinStart + Trigger_Offset_Calc, &SIGNAL2[0], &SIGNAL2_Intpolate[0]); }
			
			if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4))	//delayed mode
			{ Interpolate(dmode_Selected_Timebase, draw_dm_ixoffset, &SIGNAL2[0], &SIGNAL2_Intpolate_delayed[0]); }
		}	
		//4-Channel Version
		if (NumberOfChannels > 2)
		{	
			if (Channel_3_Active)
			{	
				if (Selected_Timebase < 4)
				{ Interpolate(Selected_Timebase, MemWinStart + Trigger_Offset_Calc, &SIGNAL3[0], &SIGNAL3_Intpolate[0]); }
				
				if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4))	//delayed mode
				{ Interpolate(dmode_Selected_Timebase, draw_dm_ixoffset, &SIGNAL3[0], &SIGNAL3_Intpolate_delayed[0]); }
			}	
			
			if (Channel_4_Active)
			{		   	
				if (Selected_Timebase < 4)
				{ Interpolate(Selected_Timebase, MemWinStart + Trigger_Offset_Calc, &SIGNAL4[0], &SIGNAL4_Intpolate[0]); }
				
				if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4))	//delayed mode
				{ Interpolate(dmode_Selected_Timebase, draw_dm_ixoffset, &SIGNAL4[0], &SIGNAL4_Intpolate_delayed[0]); }
			}
		}	

	}
	
	//---------------------------------------------------------------------------------------
	//				Noise suppression
	//---------------------------------------------------------------------------------------
		
	if (MenuStatus[MENU_ACQUIRE][2] && draw_factor > 1 && FFT_Mode == FFT_OFF && USTB_Mode == USTB_OFF)
	{
		int lstop = draw_start + (GRID_WIDTH * draw_factor) + draw_factor;
		int lmin;					//values to the left side
		int lmax;					//values to the right side
		int lsum;					//totals


		if (draw_factor == 2)
		{
			lmin = -1;
			lmax = 1;	

			for(int i=draw_start;i < lstop ;i+=draw_factor)		// go to next value
			{
				if (Channel_1_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL1[i+f];
				
					SIGNAL1[i] = (unsigned char)(lsum/3);	// calculate average
				}
				if (Channel_2_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL2[i+f];
				
					SIGNAL2[i] = (unsigned char)(lsum/3);	// calculate average
				}
				if (Channel_3_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL3[i+f];
				
					SIGNAL3[i] = (unsigned char)(lsum/3);	// calculate average
				}
				if (Channel_4_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL4[i+f];
				
					SIGNAL4[i] = (unsigned char)(lsum/3);	// calculate average
				}
			}

		}
		else if (draw_factor == 4 || draw_factor == 5)
		{
			lmin = -3;
			lmax = 4;
	
			for(int i=draw_start;i < lstop ;i+=draw_factor)		// go to next value
			{
				if (Channel_1_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL1[i+f];
					
					SIGNAL1[i] = (unsigned char)(lsum>>3);	// calculate average
				}
				if (Channel_2_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL2[i+f];
					
					SIGNAL2[i] = (unsigned char)(lsum>>3);	// calculate average
				}
				if (Channel_3_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL3[i+f];
					
					SIGNAL3[i] = (unsigned char)(lsum>>3);	// calculate average
				}
				if (Channel_4_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL4[i+f];
					
					SIGNAL4[i] = (unsigned char)(lsum>>3);	// calculate average
				}

			}
		}
		else if (draw_factor >= 10)
 		{
			lmin = -7;
			lmax = 8;
	
			for(int i=draw_start;i < lstop ;i+=draw_factor)	// go to next value
			{
				if (Channel_1_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL1[i+f];
					
					SIGNAL1[i] = (unsigned char)(lsum>>4);	// calculate average
				}
				if (Channel_2_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL2[i+f];
					
					SIGNAL2[i] = (unsigned char)(lsum>>4);	// calculate average
				}
				if (Channel_3_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL3[i+f];
					
					SIGNAL3[i] = (unsigned char)(lsum>>4);	// calculate average
				}
				if (Channel_4_Active)
				{
					lsum = 0;
					for(int f=lmin;f<=lmax;f++)		// add the values from the left and the right
					lsum += SIGNAL4[i+f];
					
					SIGNAL4[i] = (unsigned char)(lsum>>4);	// calculate average
				}
			}
		}

	}

	//---------------------------------------------------------------------------------------
	//				MATH functions
	//---------------------------------------------------------------------------------------
	
	if (Channel_Math_Active == 1)
	{

		//---------------------------------------------
		//         MATH function FFT
		//---------------------------------------------
		if (FFT_Mode != FFT_OFF)               	// fft
		{
			if(FFT_NewData)	// BF calculate spectrum
			{ 
				if(Channel_1_Active) FFT_CalcSpectrum(&SIGNAL1[0],&SPECTRUM[0]);
				else if(Channel_2_Active) FFT_CalcSpectrum(&SIGNAL2[0],&SPECTRUM[0]);
				else if(Channel_3_Active) FFT_CalcSpectrum(&SIGNAL3[0],&SPECTRUM[0]);
				else if(Channel_4_Active) FFT_CalcSpectrum(&SIGNAL4[0],&SPECTRUM[0]);
			}	
			
			return;
		}	

		//---------------------------------------------
		//         MATH function multiply
		//---------------------------------------------
		if ((MenuStatus[26][2] == 1) && ((Channel_1_Active) && (Channel_2_Active)))      		// multiply 
		{	
			//set global math scaling and offset for drawing routine
			math_scale = math_mul_scale - 166;
			Math_Offset = Math_Mul_Offset;
			
			//calculate main math signal
			CalcMathMul(draw_start, lcalcstop, lfactor, lp_sig1, lp_sig2, lp_sigM);
			
			//calculate delayed math signal
			if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4))
			{ CalcMathMul(0, GRID_WIDTH+1, 1, &SIGNAL1_Intpolate_delayed[0], &SIGNAL2_Intpolate_delayed[0], &SIGNALM_Intpolate_delayed[0]); }
		}	//multiply end

		//---------------------------------------------
		//         MATH function subtract
		//---------------------------------------------

		else if ((MenuStatus[26][3] == 1) && ((Channel_1_Active) && (Channel_2_Active)))            	// subtract
		{	
			//set global math scaling and offset for drawing routine
			math_scale = math_sub_scale - 150;
			Math_Offset = Math_Sub_Offset;
			
			//calculate main math signal
			CalcMathSub(draw_start, lcalcstop, lfactor, lp_sig1, lp_sig2, lp_sigM);

			//calculate delayed math signal
			if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4))
			{ CalcMathSub(0, GRID_WIDTH+1, 1, &SIGNAL1_Intpolate_delayed[0], &SIGNAL2_Intpolate_delayed[0], &SIGNALM_Intpolate_delayed[0]); }
		}	//subtract end

		//---------------------------------------------
		//         MATH function add
		//---------------------------------------------
		else if ((MenuStatus[26][4] == 1) && ((Channel_1_Active) && (Channel_2_Active)))            	// add
		{
			//set global math scaling and offset for drawing routine
			math_scale = math_add_scale - 150;
			Math_Offset = Math_Add_Offset;
			
			//calculate main math signal
			CalcMathAdd(draw_start, lcalcstop, lfactor, lp_sig1, lp_sig2, lp_sigM);

			//calculate delayed math signal
			if ((MenuStatus[10][1] == 1) && (dmode_Selected_Timebase < 4))
			{ CalcMathAdd(0, GRID_WIDTH+1, 1, &SIGNAL1_Intpolate_delayed[0], &SIGNAL2_Intpolate_delayed[0], &SIGNALM_Intpolate_delayed[0]); }
		}	//add end
/*
		else if (MenuStatus[26][5] == 1)            // free -> not available
		{
		for (ix2 = 0; ix2 < 16384; ix2++)
			{
				SIGNALM[ix2] = (unsigned char) ((int) 127 + (((int) SIGNAL1[ix2] - ((ZeroLevelCH1 + (int) 60) >> 1)) - ((int) SIGNAL2[ix2] - ((ZeroLevelCH2 + (int) 60) >> 1))));
			}
		}
*/


	}//Math End


} //Signal processing end 
