#include "hardware_t.h"
#include "tc_vars.h"
#include "flash_t.h"
#include "display_t.h"
//#include "math.h"

// Class Display
//##########################################################################################################################################################

void Display::Test_Pixels(int x, int y, int y2, int dir, unsigned long *planeaddress)
{
    asm("
             MOV	%r1, %i0                       ; Load X to %r1

             MOV	%r2, %i0                       ; Load X to %r2
             LSRI   %r2, 5                         ; Shift %r2 right 5 times to calculate wordoffset (x / 32)      Bitfilter
             LSLI   %r2, 2                         ; Shift %r2 left 2 times to calculate wordoffset (x / 32) * 4

             MOV	%r3, %i1                       ; Load Y to %r3

             MOV    %r4, %r3                       ; Save %r3 to %r4

             LSLI   %r3, 2                         ; Shift %r3 2 times to get Y * 4
             ADD    %r3, %r4                       ; Add %r4 to %r3 to get Y * 5
             LSLI   %r3, 4                         ; Shift %r3 4 times to get Y * 80

             ADD    %r3, %r2                       ; Add wordoffset to y offset address and store in %r3

             LSLI   %r2, 3                         ; Shift %r0 to get wordoffset without bit value

             SUB    %r1, %r2                       ; Subtract %r2 from %r1 to get Bitaddress stored in %r1

             ;MOV	%r4, %i4                       ; Load BufferAddress to %r4

             PFX	%hi(0x0093A200)                ; Load BufferAddress
             MOVI	%r4,%lo(0x0093A200)
             PFX	%xhi(0x0093A200)
             MOVHI	%r4,%xlo(0x0093A200)

             ADD    %r4, %r3                       ; Calculate Memoryaddress

             PFX	%hi(0x80000000)                ; Load bitmask
             MOVI	%r5,%lo(0x80000000)
             PFX	%xhi(0x80000000)
             MOVHI	%r5,%xlo(0x80000000)

             LSR    %r5, %r1                       ; Calculate Bit to set


             MOV	%r6, %i2                       ; Load End Y to %r6

             SUB    %r6, %i1                       ; Get the Difference

             cp_loop4:

             LD     %r0, [%r4]                     ; Load Value from Memory
             OR     %r0, %r5                       ; Set Calculated Bit
             ST     [%r4], %r0                     ; Store Back to Memory

             PFX    %hi(80)
             ADDI   %r4, %lo(80)                   ; Add 80 to Address

             SUBI   %r6, 1                         ; Decrement Y Counter
             SKPS   cc_z                           ; Test of Zero
             BR     cp_loop4                       ; Jump to Loop
             NOP

         ");
}

//##########################################################################################################################################################

// BF -> generate test signals on all channels
void Display::TestSignalGenerate(void)
{
	int ix, iy, tog, pw;
	int  lVirtual_Zero = 0;
	char lDCOffset     = 0;

	if (Channel_1_Active)	// draw rectangle signal
	{
		lVirtual_Zero = ADC_ZERO + (int)((float)Virtual_ZeroLevelCH1 / scale_factor[Selected_Voltage_CH1]);
		if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
		if (lVirtual_Zero < 0) lVirtual_Zero = 0;
	
		// Signal 1 (Yellow)
		tog = 0;
		iy = lVirtual_Zero + 100;		//Amplitude

		if ( MenuStatus[MENU_CHANNEL1][0] == 8) 	//AC
		lDCOffset = 0;//-20;
		else if ( MenuStatus[MENU_CHANNEL1][0] == 7)	//DC
		lDCOffset = 0;
		else						//GND
		{
			for (ix = 0; (ix < 16384) && !UI_request; ix++)
			SIGNAL1[ix] = lVirtual_Zero;
		}
		
		if ( MenuStatus[MENU_CHANNEL1][0] != 6)
		for (ix = 0, pw = 0; (ix < 16384) && !UI_request; ix++, pw++)
		{	
			//if (ix %200 == 0) 		//Pulswidth
			//if (ix %50 == 0) 		//Pulswidth
			if(pw==50)			//Pulswidth
			{
				pw = 0;
				if (tog == 0) tog = 1;
				else tog = 0;
			}
			
			if (tog == 0)
			{ iy = lVirtual_Zero - 73; }	//Amplitude
			else
			{ iy = lVirtual_Zero + 72;}	//Amplitude
	
			if (iy > 255) iy = 255;	//Limiter
			if (iy < 0) iy = 0;
		
			SIGNAL1[ix] = (char)iy + lDCOffset;
		}	
	
	}

	if (Channel_2_Active)
	{
		lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH2 / scale_factor[Selected_Voltage_CH2]);
		if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
		if (lVirtual_Zero < 0) lVirtual_Zero = 0;

		// Signal 2 (Green)
		tog = 0;	
		iy = lVirtual_Zero;
	
		if ( MenuStatus[MENU_CHANNEL2][0] == 8) 	//AC
		lDCOffset = 0;
		else if ( MenuStatus[MENU_CHANNEL2][0] == 7)	//DC
		lDCOffset = 20;
		else						//GND
		{
			for (ix = 0; (ix < 16384) && !UI_request; ix++)
			SIGNAL2[ix] = lVirtual_Zero;
		}

		if ( MenuStatus[MENU_CHANNEL2][0] != 6)
		// calculate sinus signal
		for (ix = 0, iy = 0; (ix < 16384) && !UI_request; ix++, iy+=4)
		{
			if(iy >= 1024)
			iy = 0;

			SIGNAL2[ix] = lVirtual_Zero + (iSin1024[iy] >> 4);
		}
		
/*
		// calculate triangle signal
		for (ix = 0; (ix < 16384) && !UI_request; ix++)
		{
			if (ix %80 == 0)
			{
				if (tog == 0) tog = 1;
				else tog = 0;
			}
			
			if (ix %2 == 0)
			{
				if (tog == 0) iy++;
				else iy--;
			}
			if (iy > 255) iy = 255;	//Limiter
			if (iy < 0) iy = 0;

			SIGNAL2[ix] = (char)iy + lDCOffset;
		}	
*/	
	}

	if (NumberOfChannels == 2)
	return;

	if (Channel_3_Active)
	{
		lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH3 / scale_factor[Selected_Voltage_CH3]);
		if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
		if (lVirtual_Zero < 0) lVirtual_Zero = 0;

		// Signal 3 (Purple)
		tog = 0;	
		iy = lVirtual_Zero + 25;
		
		if ( MenuStatus[MENU_CHANNEL3][0] == 8) 	//AC
		lDCOffset = -30;
		else if ( MenuStatus[MENU_CHANNEL3][0] == 7)	//DC
		lDCOffset = 0;
		else						//GND
		{
			for (ix = 0; (ix < 16384) && !UI_request; ix++)
			SIGNAL3[ix] = lVirtual_Zero;
		}

		
		if ( MenuStatus[MENU_CHANNEL3][0] != 6)
		for (ix = 0, pw = 0; (ix < 16384) && !UI_request; ix++,pw++)
		{	
			//if (ix %150 == 0) 		//Pulswidth
			if (pw == 150) 			//Pulswidth
			{
				pw = 0;
				if (tog == 0) tog = 1;
				else tog = 0;
			}
			
			if (tog == 0)
			{ iy = lVirtual_Zero - 25; }	//Amplitude
			else
			{ iy = lVirtual_Zero + 25;}	//Amplitude
	
			if (iy > 255) iy = 255;	//Limiter
			if (iy < 0) iy = 0;
		
			SIGNAL3[ix] = (char)iy + lDCOffset;
		}	
	}

	if (Channel_4_Active)
	{
		lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH4 / scale_factor[Selected_Voltage_CH4]);
		if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
		if (lVirtual_Zero < 0) lVirtual_Zero = 0;

		// Signal 4 (Red)
		tog = 0;	
		iy = lVirtual_Zero;
		
		
		if ( MenuStatus[MENU_CHANNEL4][0] == 8) 	//AC
		lDCOffset = 0;
		else if ( MenuStatus[MENU_CHANNEL4][0] == 7)	//DC
		lDCOffset = 25;
		else						//GND
		{
			for (ix = 0; (ix < 16384) && !UI_request; ix++)
			SIGNAL4[ix] = lVirtual_Zero;
		}
	
		if ( MenuStatus[MENU_CHANNEL4][0] != 6)
		for (ix = 0; (ix < 16384) && !UI_request; ix++)
		{
			if (ix %100 == 0)			//period
			{
				if (tog == 0) tog = 1;
				else tog = 0;
			}
			
			if (ix %2 == 0)	 			//Amplitude
			{
				if (tog == 0) iy++;
				else iy--;
			}
			if (iy > 255) iy = 255;	//Limiter
			if (iy < 0) iy = 0;

			SIGNAL4[ix] = (char)iy + lDCOffset;
		}	
	}
	if(FFT_Mode != FFT_OFF)
	FFT_NewData = 1;


}
//##########################################################################################################################################################

void Display::DrawColorDemoBox(int posx, int posy, int sizex, int sizey, unsigned long *planeaddress)							
{
    int x;

	for (x = 0; x <= sizex; x++)
	{
	   Connect_Pixels(posx + x, posy, posy + sizey, 1, planeaddress, 1);
    }
}
//##########################################################################################################################################################

void Display::ColorDemo(void)
{
    int x;

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}	


    // All Colors
	for (x = 0; x < 15; x++)
	{
	    DrawColorDemoBox(x * 40, 0, 39, 39, (unsigned long *) (0x0095FA00 + (x * 0x00009600)));
	}

    // UI Blocks
	for (x = 0; x < 5; x++)
	{
	    DrawColorDemoBox(x * 128, 40, 127, 37, (unsigned long *) (0x0095FA00 + (x * 0x00009600)));
	}
	
	// UI Mix 1
	DrawColorDemoBox(0, 46, 32, 27, UI_Plane2);
	DrawColorDemoBox(32, 46, 32, 27, UI_Plane3);
	DrawColorDemoBox(64, 46, 32, 27, UI_Plane4);
	DrawColorDemoBox(96, 46, 32, 27, UI_Plane5);
	
	// UI Mix 2
	DrawColorDemoBox(128, 46, 32, 27, UI_Plane1);
	DrawColorDemoBox(160, 46, 32, 27, UI_Plane3);
	DrawColorDemoBox((GRID_HEIGHT / 2), 46, 32, 27, UI_Plane4);
	DrawColorDemoBox(224, 46, 32, 27, UI_Plane5);

	// UI Mix 3
	DrawColorDemoBox(256, 46, 32, 27, UI_Plane1);
	DrawColorDemoBox(288, 46, 32, 27, UI_Plane2);
	DrawColorDemoBox(320, 46, 32, 27, UI_Plane4);
	DrawColorDemoBox(352, 46, 32, 27, UI_Plane5);

	// UI Mix 4
	DrawColorDemoBox(GRID_HEIGHT, 46, 32, 27, UI_Plane1);
	DrawColorDemoBox(416, 46, 32, 27, UI_Plane2);
	DrawColorDemoBox(448, 46, 32, 27, UI_Plane3);
	DrawColorDemoBox(480, 46, 32, 27, UI_Plane5);

	// UI Mix 5
	DrawColorDemoBox(512, 46, 32, 27, UI_Plane1);
	DrawColorDemoBox(544, 46, 32, 27, UI_Plane2);
	DrawColorDemoBox(576, 46, 32, 27, UI_Plane3);
	DrawColorDemoBox(608, 46, 32, 27, UI_Plane4);
	
	// Channel 4 remix
	DrawColorDemoBox(0, 70, 639, 9, Channel_Plane4);
	
	
	Connect_Pixels(123, 210, 220, 1, UI_Plane1, 1);
	Connect_Pixels(123, 220, 230, 1, UI_Plane2, 1);
	Connect_Pixels(123, 230, 240, 1, UI_Plane3, 1);
	Connect_Pixels(123, 240, 250, 1, UI_Plane4, 1);
	Connect_Pixels(123, 250, 260, 1, UI_Plane5, 1);
	Connect_Pixels(123, 260, 270, 1, Channel_Plane1, 1);
	Connect_Pixels(123, 270, 280, 1, Channel_Plane2, 1);
	Connect_Pixels(123, 280, 290, 1, Channel_Plane3, 1);
	Connect_Pixels(123, 290, 300, 1, Channel_Plane4, 1);
	Connect_Pixels(123, 300, 310, 1, Channel_Math_Plane, 1);
	Connect_Pixels(123, 310, 320, 1, Memory_Plane1, 1);
	Connect_Pixels(123, 320, 330, 1, Memory_Plane2, 1);
	Connect_Pixels(123, 330, 340, 1, Memory_Plane3, 1);
	Connect_Pixels(123, 340, 350, 1, Marker_Plane1, 1);
	Connect_Pixels(123, 350, 360, 1, Marker_Plane2, 1);
	Connect_Pixels(123, 360, 370, 1, Grid_Plane, 1);
	
	DRAWLINEP(223, 210, 232, 210, 1, UI_Plane1);
	DRAWLINEP(223, 211, 232, 211, 1, UI_Plane2);
	DRAWLINEP(223, 212, 232, 212, 1, UI_Plane3);
	DRAWLINEP(223, 213, 232, 213, 1, UI_Plane4);
	DRAWLINEP(223, 214, 232, 214, 1, UI_Plane5);
	DRAWLINEP(223, 215, 232, 215, 1, Channel_Plane1);
	DRAWLINEP(223, 216, 232, 216, 1, Channel_Plane2);
	DRAWLINEP(223, 217, 232, 217, 1, Channel_Plane3);
	DRAWLINEP(223, 218, 232, 218, 1, Channel_Plane4);
	DRAWLINEP(223, 219, 232, 219, 1, Channel_Math_Plane);
	DRAWLINEP(223, 220, 232, 220, 1, Memory_Plane1);
	DRAWLINEP(223, 221, 232, 221, 1, Memory_Plane2);
	DRAWLINEP(223, 222, 232, 222, 1, Memory_Plane3);
	DRAWLINEP(223, 223, 232, 223, 1, Marker_Plane1);
	DRAWLINEP(223, 224, 232, 224, 1, Marker_Plane2);
	DRAWLINEP(223, 225, 232, 225, 1, Grid_Plane);
	
	
	
	
	// Stop the system
    while (1 != 0);
}
//##########################################################################################################################################################
// BF color demo to check planes and colors
// BF -> UI_Plane1 has a shift error of 32 pixels to the right !!!!!!!!!!!!!!!!!!
// BF this error causes wrong lines at button drawing 
void Display::ColorDemo2(void)
{
    int x;

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}

	TEXTOUTxvbig("UI_Plane1", 40, 5, 1, UI_Plane1);				// white/grey
	TEXTOUTxvbig("UI_Plane2", 40, 20, 1, UI_Plane2);			// black
	TEXTOUTxvbig("UI_Plane3", 40, 35, 1, UI_Plane3);			// light yellow
	TEXTOUTxvbig("UI_Plane4", 40, 50, 1, UI_Plane4);			// yellow
	TEXTOUTxvbig("UI_Plane5", 40, 65, 1, UI_Plane5);			// dark grey
	TEXTOUTxvbig("Channel_Plane1", 40, 80, 1, Channel_Plane1);		// neon yellow
	TEXTOUTxvbig("Channel_Plane2", 40, 95, 1, Channel_Plane2);		// neon green
	TEXTOUTxvbig("Channel_Plane3", 40, 110, 1, Channel_Plane3);		// neon blue
	TEXTOUTxvbig("Channel_Plane4", 40, 125, 1, Channel_Plane4);		// neon red
	TEXTOUTxvbig("Channel_Math_Plane", 40, 140, 1, Channel_Math_Plane);	// neon pink
	TEXTOUTxvbig("Marker_Plane1", 40, 155, 1, Marker_Plane1);		// neon orange
	TEXTOUTxvbig("Marker_Plane2", 40, 170, 1, Marker_Plane2);		// neon orange
	TEXTOUTxvbig("Grid_Plane", 40, 185, 1, Grid_Plane);			// dark grey - white


	//----------------------------------------------------
	
	DRAWLINEP(0, 200, 639, 200, 1, UI_Plane1);
	DRAWLINEP(0, 205, 639, 205, 1, UI_Plane2);
	DRAWLINEP(0, 210, 639, 210, 1, UI_Plane3);
	DRAWLINEP(0, 215, 639, 215, 1, UI_Plane4);
	DRAWLINEP(0, 220, 639, 220, 1, UI_Plane5);

	DRAWLINEP(0, 225, 639, 225, 1, Channel_Plane1);
	DRAWLINEP(0, 230, 639, 230, 1, Channel_Plane2);
	DRAWLINEP(0, 235, 639, 235, 1, Channel_Plane3);
	DRAWLINEP(0, 240, 639, 240, 1, Channel_Plane4);
	DRAWLINEP(0, 245, 639, 245, 1, Channel_Math_Plane);

	DRAWLINEP(0, 250, 639, 250, 1, Marker_Plane1);
	DRAWLINEP(0, 255, 639, 255, 1, Marker_Plane2);

	DRAWLINEP(0, 260, 639, 260, 1, Grid_Plane); 	

	//----------------------------------------------------
	
	DRAWLINEP(0, 300, 603, 300, 1, UI_Plane1);
	DRAWLINEP(0, 305, 603, 305, 1, UI_Plane2);
	DRAWLINEP(0, 310, 603, 310, 1, UI_Plane3);
	DRAWLINEP(0, 315, 603, 315, 1, UI_Plane4);
	DRAWLINEP(0, 320, 603, 320, 1, UI_Plane5);

	DRAWLINEP(0, 325, 603, 325, 1, Channel_Plane1);
	DRAWLINEP(0, 330, 603, 330, 1, Channel_Plane2);
	DRAWLINEP(0, 335, 603, 335, 1, Channel_Plane3);
	DRAWLINEP(0, 340, 603, 340, 1, Channel_Plane4);
	DRAWLINEP(0, 345, 603, 345, 1, Channel_Math_Plane);

	DRAWLINEP(0, 350, 603, 350, 1, Marker_Plane1);
	DRAWLINEP(0, 355, 603, 355, 1, Marker_Plane2);

	DRAWLINEP(0, 360, 603, 360, 1, Grid_Plane); 	

	//----------------------------------------------------

	DRAWLINEP(33, 400, 639, 400, 1, UI_Plane1);
	DRAWLINEP(33, 405, 639, 405, 1, UI_Plane2);
	DRAWLINEP(33, 410, 639, 410, 1, UI_Plane3);
	DRAWLINEP(33, 415, 639, 415, 1, UI_Plane4);
	DRAWLINEP(33, 420, 639, 420, 1, UI_Plane5);

	DRAWLINEP(33, 425, 639, 425, 1, Channel_Plane1);
	DRAWLINEP(33, 430, 639, 430, 1, Channel_Plane2);
	DRAWLINEP(33, 435, 639, 435, 1, Channel_Plane3);
	DRAWLINEP(33, 440, 639, 440, 1, Channel_Plane4);
	DRAWLINEP(33, 445, 639, 445, 1, Channel_Math_Plane);

	DRAWLINEP(33, 450, 639, 450, 1, Marker_Plane1);
	DRAWLINEP(33, 455, 639, 455, 1, Marker_Plane2);

	DRAWLINEP(33, 460, 639, 460, 1, Grid_Plane); 	



/*
	DRAWLINEP(0, 150, 639, 150, 1, Memory_Plane1);
	DRAWLINEP(0, 155, 639, 155, 1, Memory_Plane2);
	DRAWLINEP(0, 160, 639, 160, 1, Memory_Plane3);
*/

	// Stop the system
    while (1 != 0);
}
//##########################################################################################################################################################

void Display::ColorDemo3(void)
{
    int x;

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}
	
	PIXELP(0, 0, 1, UI_Plane1);
	PIXELP(16, 0, 1, UI_Plane1);
	PIXELP(1, 0, 1, UI_Plane2);
	PIXELP(17, 0, 1, UI_Plane2);
	PIXELP(2, 0, 1, UI_Plane3);
	PIXELP(18, 0, 1, UI_Plane3);
	PIXELP(3, 0, 1, UI_Plane4);
	PIXELP(19, 0, 1, UI_Plane4);
	PIXELP(4, 0, 1, UI_Plane5);
	PIXELP(20, 0, 1, UI_Plane5);
	
	PIXELP(5, 0, 1, Channel_Plane1);
	PIXELP(21, 0, 1, Channel_Plane1);
	PIXELP(6, 0, 1, Channel_Plane2);
	PIXELP(22, 0, 1, Channel_Plane2);
	PIXELP(7, 0, 1, Channel_Plane3);
	PIXELP(23, 0, 1, Channel_Plane3);
	PIXELP(8, 0, 1, Channel_Plane4);
	PIXELP(24, 0, 1, Channel_Plane4);
	PIXELP(9, 0, 1, Channel_Math_Plane);
	PIXELP(25, 0, 1, Channel_Math_Plane);        	
	
	PIXELP(10, 0, 1, Memory_Plane1);
	PIXELP(26, 0, 1, Memory_Plane1);   	
	PIXELP(11, 0, 1, Memory_Plane2);
	PIXELP(27, 0, 1, Memory_Plane2);   	
	PIXELP(12, 0, 1, Memory_Plane3);
	PIXELP(28, 0, 1, Memory_Plane3);   	
	
	PIXELP(13, 0, 1, Marker_Plane1);
	PIXELP(29, 0, 1, Marker_Plane1);   	
	PIXELP(14, 0, 1, Marker_Plane2);
	PIXELP(30, 0, 1, Marker_Plane2);
       	
	PIXELP(15, 0, 1, Grid_Plane);
	PIXELP(31, 0, 1, Grid_Plane);   	
	
	// Stop the system
    while (1 != 0);
}
//##########################################################################################################################################################

void Display::ColorDemo5(void)
{
    int x;

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}

	// Clear test Plane
	for (x = 0; x < 9600; x++)
	{
        	Channel_Plane1[x] = 0;	
   		Buffer_Plane1[x] = 0;
	}
	
	DrawColorDemoBox(64, 64, 64, 64, Channel_Plane1);
	DrawColorDemoBox(172, 64, 64, 64, Buffer_Plane1);
	
    reset_watchdog->np_piodata = 0;
	
    screen_sel = 0;

	// Stop the system
    while (1 != 0);
}
//##########################################################################################################################################################

void Display::ColorDemo6(void)
{
    int x;

	// Clear All Planes
	for (x = 0; x < 153600; x++)
	{
		Planes[x] = 0;		
	}

	// Clear test Plane
	for (x = 0; x < 9600; x++)
	{
        	Channel_Plane1[x] = 0;	
		Buffer_Plane1[x] = 0;
	}
	
	DrawColorDemoBox(64, 64, 64, 64, Channel_Plane1);
	DrawColorDemoBox(172, 64, 64, 64, Buffer_Plane1);
	
    reset_watchdog->np_piodata = 1;
	
    screen_sel = 1;

	// Stop the system
    while (1 != 0);
}
