#include "hardware_t.h"
#include "tc_vars.h"
#include "flash_t.h"
#include "display_t.h"
//#include "math.h"

// Class Display
//##########################################################################################################################################################
// BF function for USTB roll mode

void Display::USTB_Clear_Buffer(void)
{
	int lVirtual_Zero=0;
	int lChannel=0;

	USTB_Roll_idx = 0; //Set pointer to beginning

	//init buffers with ground signal
	for(lChannel = 1;lChannel <= 5;lChannel++)
	{
		switch(lChannel)
		{	
			case 1 :	//Channel 1
			{
				lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH1 / scale_factor[Selected_Voltage_CH1]);
				if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
				if (lVirtual_Zero < 0) lVirtual_Zero = 0;
				
				for(int i=0;i<1200;i++) SIGNAL1_USTB[i] = (char)lVirtual_Zero;

				break;
			}
	
			case 2 :	//Channel 2
			{
				lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH2 / scale_factor[Selected_Voltage_CH2]);
				if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
				if (lVirtual_Zero < 0) lVirtual_Zero = 0;
				
				for(int i=0;i<1200;i++) SIGNAL2_USTB[i] = (char)lVirtual_Zero;

				break;
			}

			case 3 :	//Channel 3
			{
				lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH3 / scale_factor[Selected_Voltage_CH3]);
				if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
				if (lVirtual_Zero < 0) lVirtual_Zero = 0;
				
				for(int i=0;i<1200;i++) SIGNAL3_USTB[i] = (char)lVirtual_Zero;

				break;
			}

			case 4 :	//Channel 4
			{
				lVirtual_Zero = ADC_ZERO + int((float)Virtual_ZeroLevelCH4 / scale_factor[Selected_Voltage_CH4]);
				if (lVirtual_Zero > 255) lVirtual_Zero = 255;	//Limiter
				if (lVirtual_Zero < 0) lVirtual_Zero = 0;
				
				for(int i=0;i<1200;i++) SIGNAL4_USTB[i] = (char)lVirtual_Zero;

				break;
			}

			case 5 :	//Channel math
			{				
				for(int i=0;i<1200;i++) SIGNALM_USTB[i] = ADC_ZERO;
				break;
			}
	
	
		}
	
	}

}
//##########################################################################################################################################################
// BF function for USTB roll mode

void Display::USTB_roll_signal(int Time_idx, unsigned char *DataArray_in, unsigned char *Signal)
{

	int lNew_Value=0;
	int lix;

	//calculate average value of ADC data array
	for (lix = 0; lix < 128; lix++)
	{ lNew_Value += DataArray_in[lix]; }

	lNew_Value = lNew_Value >> 7;

	//write new value to the current time position
	Signal[Time_idx] = (char)lNew_Value;

//	Signal[Time_idx] = DataArray_in[1];
	
}

//##########################################################################################################################################################
// BF function for USTB shift mode

void Display::USTB_shift_signal(unsigned char *DataArray_in, unsigned char *Signal)
{

	int lNew_Value=0;
	int lix;

	//calculate average value of ADC data array
	for (lix = 0; lix < 128; lix++)
	{ lNew_Value += DataArray_in[lix]; }

	lNew_Value = lNew_Value >> 7;
	
	//shift all value one position to the right
	for (lix = GRID_WIDTH;lix >= 0;lix--)
	{ Signal[lix+1] = Signal[lix]; }

	 //copy new value on the first position
	Signal[0] = (char)lNew_Value;

}
